<?
/*******************************************************************************

	MSC Version 1.7 vom 24.06.2015

*******************************************************************************/

$version = "1.7";
$datum = "24.06.2015";

/*******************************************************************************
********************************************************************************


							INSTALLATIONSSKRIPT SCHALTPROGRAMME
							  HEIZKREISE UND WARMWASSERSYSTEM
								    BUDERUS KM200_GATEWAY


********************************************************************************
*******************************************************************************/

// KONFIGURATION
// --------------
// Skript mit den Verbindungseinstellungen zum KM200
// --------------------------------------------------
// Wenn schon ein Skript vorhanden ist mit den Einstellungen fr die Verbindung
// zum KM200, dann hier der der Variable "$skriptID" die ID zum Skript eintragen.
//
// Ist dies nicht der Fall, dann "$skriptID" leer lassen und ein Skript mit
// dem Namen "Verbindung" anlegen und den Inhalt aus dem Anhang hineinkopieren.
	$skriptID = "";


// Angabe ob nur "schreibbare" Schaltprogramme ausgelesen werden sollen!
	$writeonly = false;


// *****************************************************************************
// #############################################################################
// *****************************************************************************

// START DER INSTALLATION

// *****************************************************************************
// #############################################################################
// *****************************************************************************

   $parentID = IPS_GetParent($_IPS['SELF']);

// *****************************************************************************

	if(strlen($skriptID) == 5){
	   require_once(IPS_GetScriptFile($skriptID));
	   }
	else{
	$sid = IPS_GetScriptIDByName("Verbindung", $parentID);
		require_once(IPS_GetScriptFile($sid));
		}

// *****************************************************************************
// *****************************************************************************

// Heizkreise auslesen
	$content = km200_GetData('/heatingCircuits');
	$data = $content->references;

	$hk = array();
	$hk_lv = array();
	$hk_p = array();


	if($data == true){
	echo "\nlese Heizkreise\n";
	echo "------------------------------------------\n";

		foreach($data as $key){
	   	$tmp = explode("/", $key->id);
			$hk[] = end($tmp);
			}

	// Programme und Levels Heizkreise auslesen
		foreach($hk as $key => $hk_x){
		// Schaltlevels der Heizkreise auslesen
       	$content = km200_GetData('/heatingCircuits/'.$hk_x.'/temperatureLevels');
        	$data = $content->references;

			if($data == true){
			echo "lese Schaltlevel Heizkreis ".substr($hk_x, -1)."\n";
			echo "------------------------------------------\n";

				foreach($data as $key){
				$count = 1;
   				$tmp = explode("/", $key->id);
   				$name = end($tmp);
   				$content = km200_GetData('/heatingCircuits/'.$hk_x.'/temperatureLevels/'.$name);

              	if($content == true){
						$hk_lv[$hk_x][$name] = $name;
						$level['hk']['lvl'][] = $name;
						$level['hk']['value'][$hk_x.$count] = $content->minValue;
							$count++;
						$level['hk']['value'][$hk_x.$count] = $content->maxValue;
						if($content->minValue > 0){$level['var']['hc'][] = $name;}
                  echo "Schaltlevel - ".$name."\n";
						}
               }
            echo "------------------------------------------\n";
				}

			// Schaltprogramme der Heizkreise auslesen
           	$content = km200_GetData('/heatingCircuits/'.$hk_x.'/activeSwitchProgram');
           	$data = $content->allowedValues;

            if($data == true){
            echo "lese Schaltprogramm(e) Heizkreis ".substr($hk_x, -1)."\n";
            echo "------------------------------------------\n";

					foreach($data as $key => $name){
						$content = km200_GetData('/heatingCircuits/'.$hk_x.'/switchPrograms/'.$name);
						if($content->writeable == 1 and $writeonly == true){
							$hk_p[$hk_x][$name] = $name;
							echo "Programm - ".$name."\n";
							}
					   elseif((array_key_exists(0, $content->switchPoints) == true or $content->writeable == 1) and $writeonly == false){
							$hk_p[$hk_x][$name] = $name;
							echo "Programm - ".$name."\n";
							}
						}
					}
            echo "------------------------------------------\n";
            }
			}
		else{
   		echo "keine Daten fr Heizkreise vorhanden";
   		}

	echo "\n------------------------------------------\n";
	echo "------------------------------------------\n\n";

IPS_Sleep(2000);

// Warmwassersysteme auslesen
	$content = km200_GetData('/dhwCircuits');
	$data = $content->references;

	$dhw = array();
	$dhw_lv = array();
	$dhw_p = array();


   if($data == true){
   echo "lese Warmwassersysteme\n";
   echo "------------------------------------------\n";

		foreach($data as $key){
	   	$tmp = explode("/", $key->id);
			$dhw[] = end($tmp);
			}

	// Programme und Levels der Warmwassersysteme auslesen
		foreach($dhw as $key => $dhw_x){
		// Schaltlevels der Warmwassersysteme auslesen
		 	$content = km200_GetData('/dhwCircuits/'.$dhw_x.'/temperatureLevels');
        	$data = $content->references;

            if($data == true){
            echo "lese Schaltlevel Warmwassersystem ".substr($dhw_x, -1)."\n";
            echo "------------------------------------------\n";

					foreach($data as $key){
					$count = 1;
	   				$tmp = explode("/", $key->id);
	   				$name = end($tmp);
 	   				$content = km200_GetData('/dhwCircuits/'.$dhw_x.'/temperatureLevels/'.$name);

						if($content == true){
							$dhw_lv[$dhw_x][$name] = $name;
							$level['dhw']['lvl'][] = $name;
							if(array_key_exists("minValue", $content) == true){
								$level['dhw']['value'][$dhw_x.$count] = $content->minValue;
									$count ++;
								$level['dhw']['value'][$dhw_x.$count] = $content->maxValue;
								if($content->minValue > 0){$level['var']['dhw'][] = $name;}
								}
							else{
							   $level['dhw']['value'][$dhw_x.$count] = 0;
									$count ++;
								$level['dhw']['value'][$dhw_x.$count] = 0;
								}
							echo "Schaltlevel - ".$name."\n";
							}
						}
               echo "------------------------------------------\n";
					}
					
  			// Schaltprogramme der Warmwassersysteme auslesen
     			$content = km200_GetData('/dhwCircuits/'.$dhw_x.'/switchPrograms');
           	$data = $content->references;

            if($data == true){
            echo "lese Schaltprogramm(e) Warmwassersystem ".substr($dhw_x, -1)."\n";
            echo "------------------------------------------\n";

					foreach($data as $key => $array){
	   				$tmp = explode("/", $array->id);
	   				$name = end($tmp);

					   $content = km200_GetData('/dhwCircuits/'.$dhw_x.'/switchPrograms/'.$name);
					   if($content->writeable == 1 and $writeonly == true){
							$dhw_p[$dhw_x][$name] = $name;
							echo "Programm - ".$name."\n";
							}
					   elseif((array_key_exists(0, $content->switchPoints) == true or $content->writeable == 1) and $writeonly == false){
							$dhw_p[$dhw_x][$name] = $name;
							echo "Programm - ".$name."\n";
							}
						}
        			}
				echo "------------------------------------------\n";
           	}
			}
		else{
   		echo "keine Daten fr Warmwassersysteme vorhanden";
   		}

// Skript zusammenbauen
$content = '<?
/*******************************************************************************

	MSC - Version '.$version.' vom '.$datum.'

********************************************************************************


							INSTALLATIONSSKRIPT SCHALTPROGRAMME
							  HEIZKREISE UND WARMWASSERSYSTEM
								    BUDERUS KM200_GATEWAY


********************************************************************************
*******************************************************************************/

	$parentID = IPS_GetParent($_IPS[\'SELF\']);

// *****************************************************************************';

if(strlen($skriptID) == 5){
	$content .= '
	
   require_once(IPS_GetScriptFile('.$skriptID.'));
	$noscript = false;';
   }
else{
   $content .= '
   
	$sid = IPS_GetScriptIDByName("Verbindung", $parentID);
		require_once(IPS_GetScriptFile($sid));
		$noscript = true;';
	}

	$content.= '
	
// *****************************************************************************
// *****************************************************************************

/*******************************************************************************

    START DER KONFIGURATION

********************************************************************************

	Allgemeine Einstellungen
	---------------------------------------------------------------------------*/
//	hier bitte angeben, ob der Aufbau mit Kategorien oder mit Dummymodulen erfolgen soll
	$build = "dummy"; // "kat"

// -----------------------------------------------------------------------------

// Einstellungen Webfrontstruktur
// hier bitte die "ID" angeben unter welcher die Links fr den Webfrontaufbau
//	abgelegt werden sollen. Wenn keine "ID" angegeben wird, dann werden die Link\'s
// im Installationspfad unter "Webfront" abgelegt.
	$wf_build = "";

// Einstellungen Webfront
// hier die "ID" vom Webfront-Konfigurator eintragen, unter welchem die Installation
// durchgefhrt werden soll. Wenn der Eintrag leer bleibt, erfolgt keine Installation.
	$wfc_id = "";        		// ID des Konfigurators
   $wfc_parent = "roottp";    // ID der Untergruppe (zB.: item8468)
	$wfc_pos = 0;              // Position wo der SplitPane abgelegt werden soll
	$wfc_name = "KM200 Schaltprogramme";

// -----------------------------------------------------------------------------

// Definition fr die Variablenprofile
// wenn andere Namen gewnscht sind, knnen diese hier angepasst werden
	$profil_wochentag 			= "_HZ_Wochentag";
	$profil_auswahl_schaltpunkt= "_HZ_Auswahl_Schaltpunkt";
	$profil_stunden 				= "_HZ_Stunden";
	$profil_minuten 				= "_HZ_Minuten";
	$profil_level 					= "_HZ_Level";
	$profil_schaltpunkt		 	= "_HZ_Schaltpunkt";
	$profil_aktion		 			= "_HZ_Aktion";
	$profil_umschalten			= "_HZ_Umschalten";
	$profil_setpoint				= "_HZ_Setpoint";
	$profil_kopieren				= "_HZ_Kopieren";
	$profil_kopieren_nach		= "_HZ_Kopieren_nach";
	$profil_auswahl 				= "_HZ_Auswahl";
	$profil_programm 				= "_HZ_Programm";
	$profil_programm_aktion		= "_HZ_ProgrammAktion";';
foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '
	$profil_temp_'.$value.'    = "_HZ_Temp_'.$value.'";';
	}
foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '
	$profil_temp_'.$value.'    = "_HZ_Temp_'.$value.'";';
	}
	
$content .= '
	
// Definition fr die Variablennamen
// wenn andere Namen gewnscht sind, knnen diese hier angepasst werden
	$var_meldung	 			= "Meldung";
	$var_prog_info         	= "Informationen";
	$var_wochentag 			= "Wochentag";
	$var_auswahl_schaltpunkt= "Auswahl Schaltpunkt";
	$var_stunden 				= "Stunden";
	$var_minuten 				= "Minuten";
	$var_level 					= "Schaltlevel";
	$var_schaltpunkt		 	= "Schaltpunkte";
	$var_aktion		 			= "Aktion";
	$var_umschalten 			= "Umschalten";
	$var_setpoint	 			= "Sollwert";
	$var_kopieren				= "Profil kopieren";
	$var_kopieren_nach		= "Profil kopieren nach";
	$var_auswahl 				= "Auswahl";
	$var_programm 				= "Programm";
	$var_programm_aktion		= "Programm Aktion";
	$var_tagesprofil			= "Tagesprofil";
	$var_wochenprofil			= "Wochenprofil";
	$var_speicher				= "Programmspeicher";
	$var_speicheredit			= "Editspeicher";

/*##############################################################################


	Definieren der Heizkreise
	-----------------------------------------------------------------------------
	$hc1..2..3..x = true/false
	---------------------------
	mit dier Variable wird definiert ob der Heizkreis im Programm bercksichtigt
	werden soll oder nicht.

	HINWEIS:
	Wird der Heizkreis nicht bercksichtigt, kann beim nchsten Heizkreis
	weitergemacht werden.

	Wird der Heizkreis bercksichtigt dann noch folgendes einstellen:
	#################################################################
	------------------------
	$hc1_n..2_n..x
	------------------------
	Mit dieser Variable kann jedem Heizkreis ein Name zugeordnet werden.
	Standard ist Heizkreis 1, Heizkreis 2 etc.

	-------------------------
	$hc1_lv..2_lv..x = array(
	-------------------------
	Mit dem Array knnen die einzelnen "Schaltlevel" definiert werden, ob diese
	bercksichtigt werden sollen und welche Namen diesen Schaltlevels zugeordnet
	werden sollen.

		Als Beispiel:
		--------------
		$hc1_lv = array(
			"night" => \'Nacht\',
     	   "day" => \'Tag\',
			);

		Wrde jetzt bedeuten Schaltlevel "night" und "day" werden bercksichtigt.
   	Schaltlevel "night" bekommt den Namen "Nacht",
		Schaltlevel "day" bekommt den Namen "Tag",

	-----------------------
   $hc1_p..2_p..x = array(
   -----------------------
	Mit dem Array knnen die einzelnen Programme definiert werden, ob diese
	bercksichtigt werden soll und welche Namen diesen Programmen zugeordnet
	werden sollen.

		Als Beispiel:
		--------------
		$hc1_p = array(
			"Eigen1" => \'anwesend\',
      	"Eigen2" => \'abwesend\',
      	"Familie" => \'\',
      	"Morgen" => \'\',
      	"Abend" => \'\',
      	"Vormittag" => \'Vormittag\',
      	"Nachmittag" => \'Nachmittag\',
      	"Mittag" => \'keiner zu Hause\',
      	"Single" => \'\',
      	"Senioren" => \'\'
			);

		Wrde jetzt bedeuten Programme "Familie, Morgen, Abend, Single und Senioren"
		werden nicht bercksichtigt.
		Programm Eigen1 bekommt den Namen "anwesend",
		Programm Eigen2 bekommt den Namen "abwesend",
		Programm Vormittag bleibt unverndert,
		Programm Nachmittag bleibt unverndert,
		Programm Mittag bekommt den Namen "keiner zu Hause".

------------------------------------------------------------------------------*/
';

foreach($hk_p as $name => $prog){
	$content .= '
// Heizkreis '.substr($name, -1).'
// ------------
	$'.$name.' = true;

	// Name
	$'.$name.'_n = "Heizkreis '.substr($name, -1).'";';
	$hk_data[$name][$name.'_n']['name'] = '$'.$name.'_n';

	$content .= '
	
	// Schaltlevels
	$'.$name.'_lv = array(';

foreach($hk_lv[$name] as $key => $value){
	$end = end($hk_lv[$name]);

	if($key != $end){
	  	$content .= "
		\"".$key."\" => '".$value."',";
		$hk_data[$name][$name.'_lv'][$key] = $value;
		}
	else{
		$content .= "
		\"".$key."\" => '".$value."'
		);";
		$hk_data[$name][$name.'_lv'][$key] = $value;
		}
	}

	$content .= '

	// Schaltprogramme
	$'.$name.'_p = array(';

foreach($prog as $key => $value){
	$end = end($prog);
   if($key != $end){
	   $content .= "
		\"".$key."\" => '".$value."',";
		$hk_data[$name][$name.'_p'][$key] = $value;
		}
	else{
		$content .= "
		\"".$key."\" => '".$value."'
		);";
		$hk_data[$name][$name.'_p'][$key] = $value;
		}
	}

	$content .= '
// -----------------------------------
';
	}

	$content .= '

################################################################################


//	Definieren der Warmwassersysteme
/*	-----------------------------------------------------------------------------
	$dhw1..2..x = true/false
	-------------------------
	mit der Variable wird definiert ob das Warmwassersystem im Programm
	bercksichtigt werden soll oder nicht.

	HINWEIS:
	Wird das Warmwassersystem nicht bercksichtigt, kann beim nchsten System
	weitergemacht werden.

	Wird das Warmwassersystem bercksichtigt dann noch folgendes einstellen:
	########################################################################
	------------------------
	$dhw1_n..2_n..x
	------------------------
	Mit dieser Variable kann jedem Warmwassersystem ein Name zugeordnet werden.
	Standard ist Warmwasser 1, Warmwasser 2 etc.

	------------------------
	$dhw1_lv..2_lv..x = array(
	------------------------
	Mit dem Array knnen die einzelnen "Schaltlevel" definiert werden, ob diese
	bercksichtigt werden sollen und welche Namen diesen Schaltlevels zugeordnet
	werden sollen.

		Als Beispiel:
		--------------
		$dhw1_lv = array(
			"off" => \'Stop\',
     	   "on" => \'Start\',
			);

		Wrde jetzt bedeuten Schaltlevel "off" und "on" werden bercksichtigt.
		Schaltlevel "off" bekommt den Namen "Stop",
		Schaltlevel "on" bekommt den Namen "Start",

	-----------------------
   $dhw1_p..2_p..x = array(
   -----------------------
	Mit dem Array knnen die einzelnen Programme definiert werden, ob diese
	bercksichtigt werden soll und welche Namen diesen Programmen zugeordnet
	werden sollen.

		Als Beispiel:
		--------------
		$dhw1_p = array(
			"Eigen1" => \'Warmwasser\',
      	"Heizkreis" => \'\'
			);

		Wrde jetzt bedeuten Programm "Heizkreis" wird nicht bercksichtigt.
		Programm Eigen1 bekommt den Namen "Warmwasser".

------------------------------------------------------------------------------*/
';

foreach($dhw_p as $name => $prog){
	$content .= '
// Warmwasser '.substr($name, -1).'
// -------------
	$'.$name.' = true;

	// Name
	$'.$name.'_n = "Warmwasser '.substr($name, -1).'";';
	$dhw_data[$name][$name.'_n']['name'] = '$'.$name.'_n';

	$content .= '
	
	// Schaltlevels
	$'.$name.'_lv = array(';

foreach($dhw_lv[$name] as $key => $value){
	$end = end($dhw_lv[$name]);

	if($key != $end){
	  	$content .= "
		\"".$key."\" => '".$value."',";
		$dhw_data[$name][$name.'_lv'][$key] = $value;
		}
	else{
		$content .= "
		\"".$key."\" => '".$value."'
		);";
		$dhw_data[$name][$name.'_lv'][$key] = $value;
		}
	}

	$content .= '

	// Schaltprogramme
	$'.$name.'_p = array(';

foreach($prog as $key => $value){
	$end = end($prog);
   if($key != $end){
	   $content .= "
		\"".$key."\" => '".$value."',";
		$dhw_data[$name][$name.'_p'][$key] = $value;
		}
	else{
		$content .= "
		\"".$key."\" => '".$value."'
		);";
		$dhw_data[$name][$name.'_p'][$key] = $value;
		}
	}
}

	$content .= '

/*******************************************************************************

    ENDE DER KONFIGURATION

*******************************************************************************/


// *****************************************************************************
// #############################################################################
// *****************************************************************************

//	START DER INSTALLATION

// *****************************************************************************
// #############################################################################
// *****************************************************************************

	$auswahl_array[] = " ";

// Installation Struktur
// ----------------------
	// Strukt fr Editor anlegen
	if($build == "kat"){
	   SetKatByName($parentID, "Editor", "Editor", 1);
	   $ed_parent = IPS_GetObjectIDByIdent("Editor", $parentID);
	   }
	if($build == "dummy"){
	   SetDummyByName($parentID, "Editor", "Editor", 1);
	   $ed_parent = IPS_GetObjectIDByIdent("Editor", $parentID);
	   }

	// Strukt fr Skripte anlegen
	if($build == "kat"){
	   SetKatByName($parentID, "Skripte", "Skripte", 3);
	   $sc_parent = IPS_GetObjectIDByIdent("Skripte", $parentID);
	   }
	if($build == "dummy"){
	   SetDummyByName($parentID, "Skripte", "Skripte", 3);
	   $sc_parent = IPS_GetObjectIDByIdent("Skripte", $parentID);
	   }

	// Strukt fr Lschen anlegen
	if($build == "kat"){
	   SetKatByName($parentID, "Lschen", "Del", 10);
	   $del_parent = IPS_GetObjectIDByIdent("Del", $parentID);
	   }
	if($build == "dummy"){
	   SetDummyByName($parentID, "Lschen", "Del", 10);
	   $del_parent = IPS_GetObjectIDByIdent("Del", $parentID);
	   }
	   
	// Skripte in Strukt verschieben
	// Verbindungsskript
	if($noscript == true){
		$sid = IPS_GetScriptIDByName("Verbindung", $parentID);
			IPS_SetParent($sid, $sc_parent);
			IPS_SetPosition($sid, 4);
			IPS_SetIdent($sid, "Verbindung");
			}

	// Editor-Skript in Strukt anlegen
	if(@IPS_GetScriptIDByName("Editor", $sc_parent) == false){
		$sid_edit = IPS_CreateScript(0);

		IPS_SetParent($sid_edit, $sc_parent);
		IPS_SetPosition($sid_edit, 1);
		IPS_SetName($sid_edit, "Editor");
		IPS_SetIdent($sid_edit, "Editor");
		}

	// Config-Skript in Strukt anlegen
	if(@IPS_GetScriptIDByName("Config", $sc_parent) == false){
		$sid_conf = IPS_CreateScript(0);

		IPS_SetParent($sid_conf, $sc_parent);
		IPS_SetPosition($sid_conf, 2);
		IPS_SetName($sid_conf, "Config");
		IPS_SetIdent($sid_conf, "Config");
		}
		
	// Funktions-Skript in Strukt anlegen
	if(@IPS_GetScriptIDByName("Funktionen", $sc_parent) == false){
		$sid_func = IPS_CreateScript(0);

		IPS_SetParent($sid_func, $sc_parent);
		IPS_SetPosition($sid_func, 3);
		IPS_SetName($sid_func, "Funktionen");
		IPS_SetIdent($sid_func, "Funktionen");
		}

   if(strlen($wf_build) != 5){
		if($build == "kat"){
	   	SetKatByName($parentID, "Webfront", "Webfront", 4);
	   	$wf_parent = IPS_GetObjectIDByIdent("Webfront", $parentID);
	   	}
		if($build == "dummy"){
	   	SetDummyByName($parentID, "Webfront", "Webfront", 4);
	   	$wf_parent = IPS_GetObjectIDByIdent("Webfront", $parentID);
	   	}
		}

	// Variablenprofile anlegen
		create_profil($profil_wochentag, 1, 0, 0, 0, "", "", array(0 => "Mo", 1 => "Di", 2 => "Mi", 3 => "Do", 4 => "Fr", 5 => "Sa", 6 => "So"), "");
		create_profil($profil_auswahl_schaltpunkt, 1, 1, 1, 1, "- ", " -",  "", "");
  		create_profil($profil_stunden, 1, 0, 24, 1, "", "", "", "");
		create_profil($profil_minuten, 1, 0, 50, 10, "", "", "", "");
   	create_profil($profil_level, 1, 0, 0, 0, "", "", array(0 => "ein", 1 => "aus"), "");
   	create_profil($profil_schaltpunkt, 1, 0, 0, 0, "", "",  array(0 => "Schaltpunkt lschen", 1 => "Schaltpunkt einfgen"), array(0 => "#cc0000", 1 => "#008800"));
  		create_profil($profil_aktion, 1, 0, 0, 0, "", "", "Aktion", "#3366FF");
  		create_profil($profil_umschalten, 1, 0, 0, 0, "", "", array(0 => " ", 1 => "Profil kopieren", 2 => "Sollwert(e) ndern"), array(0 => "", 1 => "#0099FF", 2 => "#9933FF"));
   	create_profil($profil_kopieren_nach, 1, 0, 0, 0, "", "", array(0 => "Mo", 1 => "Di", 2 => "Mi", 3 => "Do", 4 => "Fr", 5 => "Sa", 6 => "So"), "");
      create_profil($profil_kopieren, 1, 0, 0, 0, "", "", "Profil kopieren", "#0099FF");
      create_profil($profil_setpoint, 1, 0, 0, 0, "", "", "Sollwert(e) ndern", "#9933FF");
      create_profil($profil_programm, 1, 0, 0, 0, "", "", "leer", "");
		create_profil($profil_programm_aktion, 1, 0, 0, 0, "", "", "auslesen", "#3366FF");';

	foreach(array_unique($level['var']['hc']) as $key => $value){
		$content .= '
		create_profil($profil_temp_'.$value.', 2, 0, 0, 0.5, "", " C", "", "");
		   IPS_SetVariableProfileDigits($profil_temp_'.$value.', 1);';
		}

	foreach(array_unique($level['var']['dhw']) as $key => $value){
		$content .= '
		create_profil($profil_temp_'.$value.', 2, 0, 0, 1, "", " C", "", "");
			IPS_SetVariableProfileDigits($profil_temp_'.$value.', 0);';
		}
		
	$content .= '

// *****************************************************************************

	// Instanz erstellen
		if($build == "kat"){
	   	SetKatByName($parentID, $var_speicher, "Speicher", 2);
	   	$speicher_parent = IPS_GetObjectIDByIdent("Speicher", $parentID);
	   	}
		if($build == "dummy"){
	   	SetDummyByName($parentID, $var_speicher, "Speicher", 2);
	   	$speicher_parent = IPS_GetObjectIDByIdent("Speicher", $parentID);
	   	}
	   	
// Heizkreise installieren
// ------------------------
	$pos = 1;';

foreach($hk_data as $key => $data){
$content .= '
	// Heizkreis '.substr($key, -1).'
	// -------------
	if($'.$key.' == true){
   	$auswahl_array[] = $'.$key.'_n;

	// Variable fr Schalt-Level/Programm erstellen
	$array_hk = array("sys" => array(
											"name" => "'.$key.'",
											"url_lvl" => \'/heatingCircuits/'.$key.'/temperatureLevels/\',
											"url_prog" => \'/heatingCircuits/'.$key.'/switchPrograms/\'));
		// Schaltlevel
   	foreach($'.$key.'_lv as $key => $name){
   	   if($name != \'\'){
            $array_hk[\'lvl\'][$name][\'name\'] = $key;
            $array_hk[\'lvl\'][$name][\'value\'] = 0;
            $array_hk[\'lvl\'][$name][\'minvalue\'] = 0;
            $array_hk[\'lvl\'][$name][\'maxvalue\'] = 0;
				}
			}

		// Schaltprogramme
   	foreach($'.$key.'_p as $key => $name){
   	   if($name != \'\'){
            $array_hk[\'prog\'][$name][\'name\'] = $key;
   	   	$array_hk[\'prog\'][$name][\'slotmax\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotmax_act\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Mo\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Tu\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'We\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Th\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Fr\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Sa\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'slotday_act\'][\'Su\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'time\'] = 0;
   	   	$array_hk[\'prog\'][$name][\'write\'] = 0;
            $array_hk[\'prog\'][$name][\'switchPoints\'] = "empty";
				}
			}
		$data = json_encode($array_hk);
   		CreateVariableByName($speicher_parent, '.$hk_data[$key][$key.'_n']['name'].', 3, "~String", $pos, "", $pos);
   		SetValue(IPS_GetObjectIDByIdent($pos, $speicher_parent), $data);
   		$pos++;

		}

// *****************************************************************************
';
	}

$content .= '

// Warmwassersysteme installieren
// -------------------------------';
foreach($dhw_data as $key => $data){

$content .= '

	// Warmwasser '.substr($name, -1).'
	// ------------
	if($'.$key.' == true){
   	$auswahl_array[] = $'.$key.'_n;

	// Variable fr Schalt-Level/Programm erstellen
	$array_dhw = array("sys" => array(
											"name" => "'.$key.'",
											"url_lvl" => \'/dhwCircuits/'.$key.'/temperatureLevels/\',
											"url_prog" => \'/dhwCircuits/'.$key.'/switchPrograms/\'));
      // Schaltlevel
   	foreach($'.$key.'_lv as $key => $name){
   	   if($name != \'\'){
            $array_dhw[\'lvl\'][$name][\'name\'] = $key;
            $array_dhw[\'lvl\'][$name][\'value\'] = 0;
            $array_dhw[\'lvl\'][$name][\'minvalue\'] = 0;
            $array_dhw[\'lvl\'][$name][\'maxvalue\'] = 0;
				}
			}

      // Schaltprogramme
   	foreach($'.$key.'_p as $key => $name){
   	   if($name != \'\'){
   	   	$array_dhw[\'prog\'][$name][\'name\'] = $key;
   	   	$array_dhw[\'prog\'][$name][\'slotmax\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotmax_act\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Mo\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Tu\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'We\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Th\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Fr\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Sa\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'slotday_act\'][\'Su\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'time\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'write\'] = 0;
   	   	$array_dhw[\'prog\'][$name][\'switchPoints\'] = "empty";
				}
			}
		$data = json_encode($array_dhw);
			CreateVariableByName($speicher_parent, "'.$dhw_data[$key][$key.'_n']['name'].'", 3, "~String", $pos, "", $pos);
			SetValue(IPS_GetObjectIDByIdent($pos, $speicher_parent), $data);
			$pos++;
		}

// *****************************************************************************
';
	}
	
$content .= '

// Installation Variablen und Profile
// -----------------------------------
	// Variablenprofile anlegen
		create_profil($profil_auswahl, 1, 0, 0, 0, "", "", $auswahl_array, "");

	if($ed_parent){
	// Variablen fr Editor anlegen
	$pos = 0;
		CreateVariableByName($ed_parent, $var_meldung, 3, "~HTMLBox", "Meldung", "", $pos++);
      CreateVariableByName($ed_parent, $var_prog_info, 3, "~String", "ProgrammInfo", "", $pos++);
		CreateVariableByName($ed_parent, $var_wochentag, 1, $profil_wochentag, "Wochentag", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_auswahl_schaltpunkt, 1, $profil_auswahl_schaltpunkt, "AuswahlSchaltpunkt", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_stunden, 1, $profil_stunden, "Stunden", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_minuten, 1, $profil_minuten, "Minuten", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_level, 1, $profil_level, "Schaltlevel", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_schaltpunkt, 1, $profil_schaltpunkt, "Schaltpunkt", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_aktion, 1, $profil_aktion, "Aktion", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_umschalten, 1, $profil_umschalten, "Umschalten", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_kopieren_nach, 1, $profil_kopieren_nach, "KopierenNach", $sid_edit, $pos++);
      CreateVariableByName($ed_parent, $var_kopieren, 1, $profil_kopieren, "Kopieren", $sid_edit, $pos++);';
	foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '
		CreateVariableByName($ed_parent, $var_setpoint.\' - '.$value.'\', 2, $profil_temp_'.$value.', "Setpoint'.$value.'", $sid_edit, $pos++);';
	  	}
	foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '
		CreateVariableByName($ed_parent, $var_setpoint.\' - '.$value.'\', 2, $profil_temp_'.$value.', "Setpoint'.$value.'", $sid_edit, $pos++);';
	  	}
	$content .= '
	   CreateVariableByName($ed_parent, $var_setpoint, 1, $profil_setpoint, "EditSetpoint", $sid_edit, $pos++);
	$pos = 30;
		CreateVariableByName($ed_parent, $var_auswahl, 1, $profil_auswahl , "Auswahl", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_programm, 1, $profil_programm, "Programm", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_programm_aktion, 1, $profil_programm_aktion, "ProgrammAktion", $sid_edit, $pos++);
		CreateVariableByName($ed_parent, $var_tagesprofil, 3, "~HTMLBox", "TagAnzeige", "", $pos++);
		CreateVariableByName($ed_parent, $var_wochenprofil, 3, "~HTMLBox", "WocheAnzeige", "", $pos++);
		CreateVariableByName($ed_parent, $var_speicheredit, 3, "~String", "EditSpeicher", "", 40);
		}

// *****************************************************************************

// Installation Struktur Webfront
// -------------------------------
	if(strlen($wf_build) == 5){$_parent = $wf_build;}
	else{$_parent = $wf_parent;}
	
	if($_parent){
	$pos = 0;
	// Kategorien anlegen
   	$kid = SetKatByName($_parent, $wfc_name, "KM200SP", $pos++);
   	$kid_l = SetKatByName($kid, "Links", "KM200Links", $pos++);
   	$kid_r = SetKatByName($kid, "Rechts", "KM200Rechts", $pos++);
   	   $kid_ro = SetKatByName($kid_r, "oben", "KM200RechtsOben", $pos++);
   	   $kid_ru = SetKatByName($kid_r, "unten", "KM200RechtsUnten", $pos++);

	// Links erstellen (linke Seite)
	$pos = 0;
	   SetLinkByName($kid_l, $var_auswahl, $var_auswahl, "Auswahl", $pos++);
	   $lid = SetLinkByName($kid_l, $var_programm, $var_programm, "Programm", $pos++);
	      IPS_SetHidden($lid, true);
	   $lid = SetLinkByName($kid_l, $var_programm_aktion, $var_programm_aktion, "ProgrammAktion", $pos++);
	      IPS_SetHidden($lid, true);
	   SetLinkByName($kid_l, $var_wochenprofil, $var_wochenprofil, "WocheAnzeige", $pos++);
	   SetLinkByName($kid_l, $var_tagesprofil, $var_tagesprofil, "TagAnzeige", $pos++);

	// Links erstellen (rechte Seite)
		// oben
		$pos = 0;
		SetLinkByName($kid_ro, $var_meldung, $var_meldung, "Meldung", $pos++);
	   $did = SetDummyByName($kid_ro, "Editieren", "Editieren", $pos++);
	      IPS_SetHidden($did, true);
	      $posu = 0;
		      SetLinkByName($did, $var_prog_info, $var_prog_info, "ProgrammInfo", $posu++);
  				SetLinkByName($did, $var_wochentag, $var_wochentag, "Wochentag", $posu++);
	      	SetLinkByName($did, $var_auswahl_schaltpunkt, $var_auswahl_schaltpunkt, "AuswahlSchaltpunkt", $posu++);
	      	SetLinkByName($did, "", $var_schaltpunkt, "Schaltpunkt", $posu++);
	      	SetDummyByName($did, "", "Frei", $posu++);
	      	SetLinkByName($did, $var_stunden, $var_stunden, "Stunden", $posu++);
	      	SetLinkByName($did, $var_minuten, $var_minuten, "Minuten", $posu++);
	      	SetLinkByName($did, $var_level, $var_level, "Schaltlevel", $posu++);
		$lid = SetLinkByName($kid_ro, $var_aktion, $var_aktion, "Aktion", $pos++);
		   IPS_SetHidden($lid, true);

		// unten
		$pos = 0;
		$lid = SetLinkByName($kid_ru, "", $var_umschalten, "Umschalten", $pos++);
		   IPS_SetHidden($lid, true);
		$did = SetDummyByName($kid_ru, "Profil kopieren", "KopierenDummy", $pos++);
         IPS_SetHidden($did, true);
         $posu = 0;
         	SetLinkByName($did, "von Wochentag", $var_wochentag, "Wochentag", $posu++);
	      	SetLinkByName($did, "nach Wochentag", $var_kopieren_nach, "KopierenNach", $posu++);
	      	SetLinkByName($did, "", $var_kopieren, "Kopieren", $posu++);
	   $did = SetDummyByName($kid_ru, "Sollwerte ndern", "SetpointDummy", $pos++);
         IPS_SetHidden($did, true);
         $posu = 0;';
		foreach(array_unique($level['var']['hc']) as $key => $value){
			$content .= '
	      	SetLinkByName($did, "'.$value.'", $var_setpoint.\' - '.$value.'\', "Setpoint'.$value.'", $posu++);';
			}
		foreach(array_unique($level['var']['dhw']) as $key => $value){
			$content .= '
	      	SetLinkByName($did, "'.$value.'", $var_setpoint.\' - '.$value.'\', "Setpoint'.$value.'", $posu++);';
			}
$content .= '
				SetLinkByName($did, "", $var_setpoint, "EditSetpoint", $posu++);
		}

// *****************************************************************************

// Installation Webfront
// ----------------------
	if((strlen($wfc_id) == 5) and (strlen($wfc_parent) >= 1)){
  		WFC_AddItem($wfc_id, "KM200SP", "SplitPane", \'{"alignmentType":1,"title":"\'.$wfc_name.\'","ratio":58}\', "$wfc_parent");
  		WFC_UpdatePosition($wfc_id, "KM200SP", $wfc_pos);
	 	WFC_AddItem($wfc_id, "links", "Category", \'{"baseID":\'.$kid_l.\'}\', "KM200SP");
	 	WFC_UpdatePosition($wfc_id, "links", 1);
    	WFC_AddItem($wfc_id, "rechts", "SplitPane", \'{"alignmentType":0,"title":"Editieren","ratio":64}\', "KM200SP");
    	WFC_UpdatePosition($wfc_id, "rechts", 2);
    	WFC_AddItem($wfc_id, "oben", "Category", \'{"baseID":\'.$kid_ro.\'}\', "rechts");
    	WFC_UpdatePosition($wfc_id, "oben", 1);
    	WFC_AddItem($wfc_id, "unten", "Category", \'{"baseID":\'.$kid_ru.\'}\', "rechts");
    	WFC_UpdatePosition($wfc_id, "unten", 2);

		IPS_ApplyChanges($wfc_id);
		}
    
// *****************************************************************************
    
    
   if(strlen($wf_build) != 5){
   	$wf_build = $wf_parent;
	   }
  	else{
		$wf_build = $wf_build;
		}
		

// Installation Editor-Skript
// ---------------------------

$content = "<?
/*******************************************************************************

	MSC - Version '.$version.' vom '.$datum.'
	
********************************************************************************


						 SKRIPT ZUM BEARBEITEN DER SCHALTPROGRAMME
							  HEIZKREISE UND WARMWASSERSYSTEM
								   BUDERUS KM200 - GATEWAY


********************************************************************************
*******************************************************************************/

	// Parents fr Root, Editor und Speicher
		\$global[\'parentID\'] = IPS_GetParent(\$_IPS[\'SELF\']);
		\$global[\'rootID\'] = IPS_GetParent(\$global[\'parentID\']);
		\$global[\'var_parentID\'] = IPS_GetObjectIDByIdent(\"Editor\", \$global[\'rootID\']);
		\$sp_parentID = IPS_GetObjectIDByIdent(\"Speicher\", \$global[\'rootID\']);

	// Parents fr Webfrontstruct
	  	\$visuID = IPS_GetObjectIDByIdent(\"KM200SP\", ".$wf_build.");
	  	\$global[\'visuL_parent\'] = IPS_GetObjectIDByIdent(\"KM200Links\", \$visuID);
	  	\$global[\'visuR_parent\'] = IPS_GetObjectIDByIdent(\"KM200Rechts\", \$visuID);
	  	\$global[\'visuR_oben\'] = IPS_GetObjectIDByIdent(\"KM200RechtsOben\", \$global[\'visuR_parent\']);
	  	\$global[\'visuR_unten\'] = IPS_GetObjectIDByIdent(\"KM200RechtsUnten\", \$global[\'visuR_parent\']);

	// Skripte fr include
		\$sid_conf = IPS_GetObjectIDByIdent(\"Config\", \$global[\'parentID\']);
		\$sid_func = IPS_GetObjectIDByIdent(\"Funktionen\", \$global[\'parentID\']);";
		if($noscript == true){
		$content .= "
		\$sid_conn = IPS_GetObjectIDByIdent(\"Verbindung\", \$global[\'parentID\']);";
			}
      $content .= "
      
// *****************************************************************************

	require_once(IPS_GetScriptFile(\$sid_conf));    // Skript mit den Konfigurationsdaten
	require_once(IPS_GetScriptFile(\$sid_func));    // Skript mit den Funktionen";
	if($noscript == true){
	$content .= "
	require_once(IPS_GetScriptFile(\$sid_conn));    // Skript mit den Verbindungsdaten";
		}
	else{
	$content .= "
	require_once(IPS_GetScriptFile('.$skriptID.'));    // Skript mit den Verbindungsdaten";
	   }
   $content .= "

// *****************************************************************************
// *****************************************************************************

if(\$_IPS[\'SENDER\'] == \"WebFront\"){
   SetValue(\$_IPS[\'VARIABLE\'], \$_IPS[\'VALUE\']);
	\$object = IPS_GetObject(\$_IPS[\'VARIABLE\']);

// -----------------------------------------------------------------------------
// Interne Zeiger erstellen und im \"globalen\" Buffer ablegen
// -----------------------------------------------------------------------------

	// Namen der Wochentag
		\$global[\'dayshort\'] = array(\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\",\"Su\");
		\$global[\'dayshort_de\'] = array(\"Mo\",\"Di\",\"Mi\",\"Do\",\"Fr\",\"Sa\",\"So\");
		\$global[\'daylong\'] = array(\'Montag\',\'Dienstag\',\'Mittwoch\',\'Donnerstag\',\'Freitag\',\'Samstag\',\'Sonntag\');

	// aktives System abfragen
		\$global[\'auswahl_value\'] = GetValue(IPS_GetObjectIDByIdent(\"Auswahl\", \$global[\'var_parentID\']));
		\$profil = IPS_GetVariableProfile(\$profile[\'Auswahl\']);
      \$global[\'auswahl\'] = \$profil[\'Associations\'][\$global[\'auswahl_value\']][\'Name\'];

	if(\$global[\'auswahl\'] != \" \"){
  	// aktives Programm abfragen
		\$global[\'programm_value\'] = GetValue(IPS_GetObjectIDByIdent(\"Programm\", \$global[\'var_parentID\']));
		\$profil = IPS_GetVariableProfile(\$profile[\'Programm\']);
      \$global[\'programm\'] = \$profil[\'Associations\'][\$global[\'programm_value\']][\'Name\'];

	// aktiven Wochentag abfragen
		\$global[\'wochentag\'] = GetValue(IPS_GetObjectIDByIdent(\"Wochentag\", \$global[\'var_parentID\']));

	// aktiven Schaltpunkt abfragen
		\$global[\'slot\'] = GetValue(IPS_GetObjectIDByIdent(\"AuswahlSchaltpunkt\", \$global[\'var_parentID\']));

	// Schqaltpunkt einfgen aktiv
		\$global[\'slot_add\'] = GetValue(IPS_GetObjectIDByIdent(\"Schaltpunkt\", \$global[\'var_parentID\']));

	// Speicher zum Programm festlegen
		// Programme und Schaltlevel
			\$global[\'sp_progID\'] = IPS_GetObjectIDByIdent(\$global[\'auswahl_value\'], \$sp_parentID);
   		\$global[\'sp_prog\'] = json_decode(GetValue(\$global[\'sp_progID\']));
		// Edit-Speicher
			\$global[\'sp_editID\'] = IPS_GetObjectIDByIdent(\"EditSpeicher\", \$global[\'var_parentID\']);
   		\$global[\'sp_edit\'] = json_decode(GetValue(\$global[\'sp_editID\']));


	// aktuelle RESTUrls
      \$global[\'url_lvl\'] = \$global[\'sp_prog\']->sys->url_lvl;
	   if(\$global[\'programm\'] != \" \"){
	   	@\$global[\'url_prog\'] = \$global[\'sp_prog\']->sys->url_prog.\$global[\'sp_prog\']->prog->\$global[\'programm\']->name;
	   	}

	// aktiven Systemtyp abfragen
	   \$global[\'system\'] = \$global[\'sp_prog\']->sys->name;
		}

// *****************************************************************************
// *****************************************************************************

// -----------------------------------------------------------------------------

// Abarbeiten der einzelnen Befehle

// -----------------------------------------------------------------------------

	switch(\$object[\'ObjectIdent\']){
	// System umschalten
		case \"Auswahl\":
			if(\$_IPS[\'VALUE\'] == 0){   // wenn kein System ausgewhlt
			   system_change(true);
				}
			else{    // wenn ein System ausgewhlt wurde
				system_change();
				}
	   break;

// *****************************************************************************

	// Programm umschalten
		case \"Programm\":
			if(\$_IPS[\'VALUE\'] == 0){   // wenn kein Programm ausgewhlt
			   programm_change(true);
				}
			else{    // wenn ein Programm ausgewhlt wurde
				programm_change();
				}
	   break;

// *****************************************************************************

	// Programm auslesen
		case \"ProgrammAktion\":
		// Meldung ausgeben
			meldung(\"005\", 2);

	// ----------------------------------------------------------------------- //

      // Schaltlevel auslesen
	   	foreach(\$global[\'sp_prog\']->lvl as \$key => \$array){
		      \$data = km200_GetData(\$global[\'url_lvl\'].\$array->name);

			// Werte von den Schaltlevels
		      \$global[\'sp_prog\']->lvl->\$key->value = \$data->value;
		      \$global[\'sp_prog\']->lvl->\$key->minvalue = \$data->minValue;
		      \$global[\'sp_prog\']->lvl->\$key->maxvalue = \$data->maxValue;
		      }

   // ----------------------------------------------------------------------- //

      // Schaltprogramm auslesen
	     \$data = km200_GetData(\$global[\'url_prog\']);

			if(isset(\$data)){
			// maximale Anzahl der TimeSlots
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotmax = \$data->maxNbOfSwitchPoints;
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotmax_act = count(\$data->switchPoints);

			// maximale Anzahl der TimeSlots pro Tag
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday = \$data->maxNbOfSwitchPointsPerDay;

  				\$days = array(\"Mo\" => 0, \"Tu\" => 0, \"We\" => 0, \"Th\" => 0, \"Fr\" => 0, \"Sa\" => 0, \"Su\" => 0);
					foreach(\$data->switchPoints as \$key => \$array){\$days[\$array->dayOfWeek]++;}

				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Mo = \$days[\'Mo\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Tu = \$days[\'Tu\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->We = \$days[\'We\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Th = \$days[\'Th\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Fr = \$days[\'Fr\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Sa = \$days[\'Sa\'];
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act->Su = \$days[\'Su\'];

			// Zeitraster des Programms
				\$global[\'sp_prog\']->prog->\$global[\'programm\']->time = \$data->switchPointTimeRaster;

			// schreiben oder nur lesen
	   	   \$global[\'sp_prog\']->prog->\$global[\'programm\']->write = \$data->writeable;

            // Schaltpunkte des Programms
				if(array_key_exists(0, \$data->switchPoints) == true){
					\$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints = \$data->switchPoints;
					meldung(\"006\", 2);
	      		}
				elseif(\$data->writeable == 1){
				   \$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints = \"noprog\";
				   meldung(\"007\", 2);
				   }
				else{
					// Meldung ausgeben
					meldung(\"008\", 2);
					SetVariable(\"TagAnzeige\", \"keine Daten beim Auslesen ... \");
					SetVariable(\"WocheAnzeige\", \"keine Daten beim Auslesen ... \");
					}
				}

			// Werte in den Datenspeicher schreiben
				SetValue(\$global[\'sp_progID\'], json_encode(\$global[\'sp_prog\']));

	// ----------------------------------------------------------------------- //

		// Anzeige neu aufbauen
			IPS_Sleep(1000);
			programm_change();
		break;

// *****************************************************************************

	// Programm Aktion (nderungen bernehmen / Programm bertragen)
		case \"Aktion\":
			\$aktion_value = GetValue(IPS_GetObjectIDByIdent(\"Aktion\", \$global[\'var_parentID\']));
			\$profil = IPS_GetVariableProfile(\$profile[\'Aktion\']);
      	\$aktion = \$profil[\'Associations\'][\$aktion_value][\'Name\'];

			if(\$aktion == \"nderungen bernehmen\"){
				switch(\$global[\'slot_add\']){
				   case -1:
                  \$result = change_zeitslot(\"change\");
					break;
				   case 1:
                  \$result = change_zeitslot(\"add\");
					break;
					}

				if(\$result == \"OK\"){
				   meldung(\"014\", 2);
        			change_link(\"Aktion\", 1);
        			change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"Programm bertragen\", \"#3366FF\");
        			SetVariable(\"Schaltpunkt\", -1);

					IPS_Sleep(500);
        			anzeige_erstellen();
        			}

				if(\$result == \"slotmax\"){
					change_link(\"Aktion\", 0);
         		change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"nderungen bernehmen\", \"#3366FF\");
         		SetVariable(\"Schaltpunkt\", -1);
         		}
         	}

  			if(\$aktion == \"Programm bertragen\"){
            meldung(\"026\", 2);
         	change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"wird bertragen ...\", \"#3366FF\");

         	write_program(\$global[\'url_prog\'], \$global[\'sp_edit\']->switchPoints);

         	IPS_Sleep(1000);
         	meldung(\"027\", 2);
         	change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"wird geprft ...\", \"#3366FF\");

			// bertragene Daten prfen
			   IPS_Sleep(1000);
				\$data = km200_GetData(\$global[\'url_prog\']);
				\$prog = json_encode(\$data->switchPoints);
				\$edit = json_encode(\$global[\'sp_edit\']->switchPoints);

				if(strcmp(\$prog, \$edit) == 0){
					meldung(\"028\", 2);

					\$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints = \$global[\'sp_edit\']->switchPoints;
					SetValue(\$global[\'sp_progID\'], json_encode(\$global[\'sp_prog\']));

					change_link(\"Aktion\", 0);
         		change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"nderungen bernehmen\", \"#3366FF\");
					}
				else{
				   meldung(\"029\", 2);
				   change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"Programm bertragen\", \"#3366FF\");
				   }
         	}
		break;

// *****************************************************************************

	// Umschalten - Profil kopieren/Sollwerte
		case \"Umschalten\":
		   switch(\$_IPS[\'VALUE\']){
		      case 0:
		   		change_link(\"KopierenDummy\", 0);
		   		change_link(\"SetpointDummy\", 0);
		   	break;
		      case 1:
		   		change_link(\"KopierenDummy\", 1);
		   		change_link(\"SetpointDummy\", 0);
		   	break;
		      case 2:
		   		change_link(\"KopierenDummy\", 0);
		   		change_link(\"SetpointDummy\", 1);

		   		if(\$global[\'system\'][0] == \"h\"){';
		   		foreach(array_unique($level['var']['hc']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 1);';
						}
		   		foreach(array_unique($level['var']['dhw']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 0);';
						}
               $content .= '
					   }
					elseif(\$global[\'system\'][0] == \"d\"){';
		   		foreach(array_unique($level['var']['hc']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 0);';
						}
		   		foreach(array_unique($level['var']['dhw']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 1);';
						}
               $content .= '
					   }
					else{';
		   		foreach(array_unique($level['var']['hc']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 0);';
						}
		   		foreach(array_unique($level['var']['dhw']) as $key => $value){
					$content .= '
						change_link(\"Setpoint'.$value.'\", 0);';
						}
               $content .= '
					   }
		   	break;
				}
	   break;

// *****************************************************************************

	// Profil kopieren
		case \"Kopieren\":
		\$nachTag = GetValue(IPS_GetObjectIDByIdent(\"KopierenNach\", \$global[\'var_parentID\']));

		// Schaltpunkte auslesen
		foreach(\$global[\'sp_edit\']->switchPoints as \$key => \$array){
			\$tmpprog[\$array->dayOfWeek][] = \$array;
			}

      \$tmpprog[\$global[\'dayshort\'][\$nachTag]] = array();

		foreach(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]] as \$key => \$array){
			@\$tmpprog[\$global[\'dayshort\'][\$nachTag]][\$key]->dayOfWeek = \$global[\'dayshort\'][\$nachTag];
			\$tmpprog[\$global[\'dayshort\'][\$nachTag]][\$key]->setpoint = \$array->setpoint;
			\$tmpprog[\$global[\'dayshort\'][\$nachTag]][\$key]->time = \$array->time;
			}

		foreach(\$tmpprog as \$key1 => \$data){
	   	foreach(\$data as \$key2 => \$array){
				\$sp_edit[] = \$array;
				}
			}

      \$global[\'sp_edit\']->switchPoints = \$sp_edit;
		SetValue(\$global[\'sp_editID\'], json_encode(\$global[\'sp_edit\']));
		SetValue(\$_IPS[\'VARIABLE\'], -1);

		meldung(\"032\", 3);
		change_link(\"Aktion\", 1);
      change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"Programm bertragen\", \"#3366FF\");

		IPS_Sleep(500);
		anzeige_erstellen();
	   break;

// *****************************************************************************

	// Profil kopieren nach
		case \"KopierenNach\":
         SetVariable(\"Kopieren\", 0);
	   break;

// *****************************************************************************';
	foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '

	// Sollwert '.$value.' ndern
		case \"Setpoint'.$value.'\":
         SetVariable(\"EditSetpoint\", 0);
	   break;

// *****************************************************************************';
	}
	foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '

	// Sollwert '.$value.' ndern
		case \"Setpoint'.$value.'\":
         SetVariable(\"EditSetpoint\", 0);
	   break;

// *****************************************************************************';
	}
	$content .= '

	// Sollwerte schreiben
		case \"EditSetpoint\":';
	foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '
		   \$setpoint'.$value.' = GetValue(IPS_GetObjectIDByIdent(\"Setpoint'.$value.'\", \$global[\'var_parentID\']));';
		   }
	foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '
		   \$setpoint'.$value.' = GetValue(IPS_GetObjectIDByIdent(\"Setpoint'.$value.'\", \$global[\'var_parentID\']));';
		   }
	$content .= '
	
		   foreach(\$global[\'sp_prog\']->lvl as \$key => \$array){';
	foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '
				if(\$array->name == \"'.$value.'\" and \$array->value != \$setpoint'.$value.'){
				   meldung(\"026\", 2);

		   		km200_SetData(\$global[\'sp_prog\']->sys->url_lvl.\"'.$value.'\", \$setpoint'.$value.');

					IPS_Sleep(500);
					meldung(\"027\", 2);

		   		\$data = km200_GetData(\$global[\'sp_prog\']->sys->url_lvl.\"'.$value.'\");
		   		\$value = \$data->value;

		   		if(\$value == \$setpoint'.$value.'){
		   		   meldung(\"028\", 2);

		   		   \$global[\'sp_prog\']->lvl->\$key->value = \$setpoint'.$value.';
               	SetValue(\$global[\'sp_progID\'], json_encode(\$global[\'sp_prog\']));
						}
		   		else{
						meldung(\"029\", 2);
						}
 		   		}
					 ';
	         }
	foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '
				if(\$array->name == \"'.$value.'\" and \$array->value != \$setpoint'.$value.'){
				   meldung(\"026\", 2);

		   		km200_SetData(\$global[\'sp_prog\']->sys->url_lvl.\"'.$value.'\", \$setpoint'.$value.');

					IPS_Sleep(500);
					meldung(\"027\", 2);

		   		\$data = km200_GetData(\$global[\'sp_prog\']->sys->url_lvl.\"'.$value.'\");
		   		\$value = \$data->value;

		   		if(\$value == \$setpoint'.$value.'){
		   		   meldung(\"028\", 2);

		   		   \$global[\'sp_prog\']->lvl->\$key->value = \$setpoint'.$value.';
               	SetValue(\$global[\'sp_progID\'], json_encode(\$global[\'sp_prog\']));
						}
		   		else{
						meldung(\"029\", 2);
						}
 		   		}';
	         }
	$content .= '
				}
				
         SetValue(\$_IPS[\'VARIABLE\'], -1);
         anzeige_erstellen();
	   break;
	   
// *****************************************************************************

	// Wochentag ndern
		case \"Wochentag\":
			anzeige_erstellen();
         meldung(\"030\", 3);
	   break;

// *****************************************************************************

	// ZeitSlot auswhlen
		case \"AuswahlSchaltpunkt\":
         anzeige_erstellen();
         meldung(\"031\", 3);
	   break;

// *****************************************************************************

	// Stunden ndern
		case \"Stunden\":
         change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"nderungen bernehmen\", \"#3366FF\");
			change_link(\"Aktion\", 1);
	   break;

// *****************************************************************************

	// Minuten ndern
		case \"Minuten\":
			change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"nderungen bernehmen\", \"#3366FF\");
			change_link(\"Aktion\", 1);
	   break;

// *****************************************************************************

	// Schaltlevel ndern
		case \"Schaltlevel\":
         change_profil(\$profile[\'Aktion\'], 1, 0, 0, 0, \"\", \"\", \"nderungen bernehmen\", \"#3366FF\");
         change_link(\"Aktion\", 1);
	   break;

// *****************************************************************************

	// Schaltpunkt einfgen/lschen
		case \"Schaltpunkt\":
			switch(\$_IPS[\'VALUE\']){
			   // Schaltpunkt lschen
			   case 0:
			      \$result = change_zeitslot(\"del\");
         			if(\$result == \"OK\"){
							meldung(\"018\", 2);
							anzeige_erstellen(true);
							}
						else{
							meldung(\"017\", 2);
						   }
					SetVariable(\"Schaltpunkt\", -1);
				break;
				// Schaltpunkt einfgen
			   case 1:
         		meldung(\"019\", 2);
				break;
				}
	   break;
		}
	}

// *****************************************************************************
// *****************************************************************************

?>";

	IPS_SetScriptContent($sid_edit, $content);
	
// *****************************************************************************


// Installation Funktions-Skript
// ------------------------------

$content = "<?
/*******************************************************************************

	MSC - Version '.$version.' vom '.$datum.'
	
********************************************************************************


                   		SKRIPT MIT DEN FUNKTIONEN
 								 	fr Buderus KM200
								Schaltprogramme bearbeiten


********************************************************************************
*******************************************************************************/

/*------------------------------------------------------------------------------
	Funktion Variable schreiben
------------------------------------------------------------------------------*/
function SetVariable(\$name, \$newvalue, \$check = false){
Global \$global;

   \$vid = IPS_GetObjectIDByIdent(\$name, \$global[\'var_parentID\']);
   if(\$check == true){
		\$oldvalue = GetValue(\$vid);
		if(\$newvalue != \$oldvalue){
			SetValue(\$vid, \$newvalue);
	   	}
		}
	else{
	   SetValue(\$vid, \$newvalue);
		}
	}


/*------------------------------------------------------------------------------
	Funktion Variablenprofil ndern
------------------------------------------------------------------------------*/
function change_profil(\$profil, \$typ, \$min, \$max, \$step, \$pre, \$suf, \$asso, \$color = false){
 \$data = @IPS_GetVariableProfile(\$profil);

	if(\$data == true){
		// Eintrge lschen
		foreach(\$data[\'Associations\'] as \$key => \$array){
			@IPS_SetVariableProfileAssociation(\$profil, \$key, \\"\\", \\"\\", -1);
			}
		}
	else{
	  	@IPS_CreateVariableProfile(\$profil, \$typ);
		IPS_SetVariableProfileValues(\$profil, \$min, \$max, \$step);
		}

// -----------------------------------------------------------------------------

   // neue Eintrge erstellen
   IPS_SetVariableProfileValues(\$profil, \$min, \$max, \$step);

	if(is_array(\$asso) == true){
		foreach(\$asso as \$key => \$value){
	   	IPS_SetVariableProfileText(\$profil, \$pre, \$suf);
	   	if(\$color == false){
				@IPS_SetVariableProfileAssociation(\$profil, \$key, \$value, \"\", -1);
			   }
			else{
				@IPS_SetVariableProfileAssociation(\$profil, \$key, \$value, \"\", hexdec(\$color[\$key]));
			   }
			}
		}
	else{
   	IPS_SetVariableProfileText(\$profil, \$pre, \$suf);
   	if(\$color == false){
  			@IPS_SetVariableProfileAssociation(\$profil, 0, \$asso, \"\", -1);
  			}
   	else{
  			@IPS_SetVariableProfileAssociation(\$profil, 0, \$asso, \"\", hexdec(\$color));
  			}
		}
	}


/*------------------------------------------------------------------------------
	Funktion Link ndern
------------------------------------------------------------------------------*/
function change_link(\$ident, \$action = 2, \$name = \"\"){
Global \$global;

// Links definieren
	\$link[\'Auswahl\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Auswahl\", \$global[\'visuL_parent\']));
	\$link[\'Programm\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Programm\", \$global[\'visuL_parent\']));
	\$link[\'ProgrammAktion\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"ProgrammAktion\", \$global[\'visuL_parent\']));

	\$link[\'Editieren\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Editieren\", \$global[\'visuR_oben\']));
	\$link[\'Aktion\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Aktion\", \$global[\'visuR_oben\']));

   \$link[\'Umschalten\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Umschalten\", \$global[\'visuR_unten\']));
	\$link[\'KopierenDummy\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"KopierenDummy\", \$global[\'visuR_unten\']));
	\$link[\'SetpointDummy\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"SetpointDummy\", \$global[\'visuR_unten\']));';
	foreach(array_unique($level['var']['hc']) as $key => $value){
	$content .= '
		\$link[\'Setpoint'.$value.'\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Setpoint'.$value.'\", \$link[\'SetpointDummy\'][\'ObjectID\']));';
		}
	foreach(array_unique($level['var']['dhw']) as $key => $value){
	$content .= '
		\$link[\'Setpoint'.$value.'\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"Setpoint'.$value.'\", \$link[\'SetpointDummy\'][\'ObjectID\']));';
		}
	$content .= '
		\$link[\'EditSetpoint\'] = IPS_GetObject(IPS_GetObjectIDByIdent(\"EditSetpoint\", \$link[\'SetpointDummy\'][\'ObjectID\']));


// Aktionen durchfhren
// ---------------------
	// Namen anpassen
	if(\$action == 3){
	   IPS_SetName(\$link[\$ident][\'ObjectID\'], \$name);
		}

	// Togglefunktion
	elseif(\$action == 2){
		// Link sichtbar
		if(\$link[\$ident][\'ObjectIsHidden\'] == true){
			IPS_SetHidden(\$link[\$ident][\'ObjectID\'], false);
			return false;
			}

		// Link unsichtbar
		if(\$link[\$ident][\'ObjectIsHidden\'] == false){
			IPS_SetHidden(\$link[\$ident][\'ObjectID\'], true);
			return true;
			}
		}
	// Sichtbar
	elseif(\$action == 1){IPS_SetHidden(\$link[\$ident][\'ObjectID\'], false);}

	// Unsichtbar
	elseif(\$action == 0){IPS_SetHidden(\$link[\$ident][\'ObjectID\'], true);}
	}


/*------------------------------------------------------------------------------
	Funktion System umschalten (Variablenprofil-Auswahl ndern)
------------------------------------------------------------------------------*/
function system_change(\$default = false){
	Global \$global, \$profile;

	if(\$default == true){
		meldung(\"000\", 0);
		\$anzeige = \"keine Daten vorhanden, bitte System auswhlen ...\";

		\$asso = \" \";
	   }
	else{
		meldung(\"001\", 1);
		\$anzeige = \"fr Anzeige Programm auswhlen ...\";

   	\$asso = array(0 => \" \");
		foreach(\$global[\'sp_prog\']->prog as \$key => \$array){
        	\$asso[] = \$key;
			}
		}

// -----------------------------------------------------------------------------

// Variablenprofil ndern
	change_profil(\$profile[\'Programm\'], 1, 0, 0, 0, \"\", \"\", \$asso, \"\");

// -----------------------------------------------------------------------------

// Sichtbarkeit setzen
	if(\$default == true){
	   change_link(\"Programm\", 0);
	   change_link(\"ProgrammAktion\", 0);
	   change_link(\"Editieren\", 0);
	   change_link(\"Aktion\", 0);
	   change_link(\"Umschalten\", 0);
	      SetVariable(\"Umschalten\", -1);
	   change_link(\"KopierenDummy\", 0);
	   change_link(\"SetpointDummy\", 0);
		}
	else{
	   change_link(\"Programm\", 1);
	   change_link(\"ProgrammAktion\", 0);
	   change_link(\"Editieren\", 0);
	   change_link(\"Aktion\", 0);
	   change_link(\"Umschalten\", 0);
	      SetVariable(\"Umschalten\", -1);
	   change_link(\"KopierenDummy\", 0);
	   change_link(\"SetpointDummy\", 0);
		}

// -----------------------------------------------------------------------------

// Variablen schreiben
	SetVariable(\"Programm\", 0);
	SetVariable(\"TagAnzeige\", \$anzeige);
	SetVariable(\"WocheAnzeige\", \$anzeige);
	}


/*------------------------------------------------------------------------------
	Funktion Programm umschalten (Variablenprofil-Programm ndern)
------------------------------------------------------------------------------*/
function programm_change(\$default = false){
	Global \$global, \$color, \$profile;

   \$empty = false;
   \$noprog = false;
   \$noedit = false;

   SetValue(\$global[\'sp_editID\'], \'{\"slotmax_act\":0,\"slotday_act\":{\"Mo\":0,\"Tu\":0,\"We\":0,\"Th\":0,\"Fr\":0,\"Sa\":0,\"Su\":0},\"switchPoints\":[{\"dayOfWeek\":\"Mo\",\"setpoint\":\"0\",\"time\":0}]}\');

// -----------------------------------------------------------------------------

	if(\$default == true){
		meldung(\"001\", 1);
		\$taganzeige = \"fr Anzeige Programm auswhlen ...\";
		\$wocheanzeige = \"fr Anzeige Programm auswhlen ...\";

		change_link(\"ProgrammAktion\", 0);
		}
	else{
		if(isset(\$global[\'sp_prog\']) == true){
			if(\$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints == \"empty\"){   // wenn Speicher leer (Programm noch nicht geladen)
				\$empty = true;
				meldung(\"010\", 2);
				\$taganzeige = \"keine Daten vorhanden, bitte Programm laden ...\";
				\$wocheanzeige = \"keine Daten vorhanden, bitte Programm laden ...\";
				}

			elseif(\$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints == \"noprog\"){   // wenn Speicher leer (Programm wurde geladen)
            \$noprog = true;
				meldung(\"011\", 2);
				\$taganzeige = \"keine Daten vorhanden, bitte Programm erstellen ...\";
				\$wocheanzeige = \"keine Daten vorhanden, bitte Programm erstellen ...\";

				// Auswahl-Zeit-Slot auf Anzahl der belegten Slots beschrnken
   				change_profil(\$profile[\'AuswahlSchaltpunkt\'], 1, 0, 0, 0, \"Slot \", \"\", \"\", \"\");

				SetValue(\$global[\'sp_editID\'], \'{\"slotmax_act\":0,\"slotday_act\":{\"Mo\":0,\"Tu\":0,\"We\":0,\"Th\":0,\"Fr\":0,\"Sa\":0,\"Su\":0},\"switchPoints\":[{\"dayOfWeek\":\"Mo\",\"setpoint\":\"0\",\"time\":0}]}\');
				}

			elseif(array_key_exists(\$global[\'programm\'], \$global[\'sp_prog\']->prog) and \$empty == false and \$noprog == false){   // wenn Parameter im Speicher vorhanden
				if(\$global[\'sp_prog\']->prog->\$global[\'programm\']->write == 0){
			      \$noedit = true;
			      meldung(\"013\", 2);
					}
				else{
				   meldung(\"012\", 2);
				   }
            \$global[\'sp_edit\']->slotmax_act = \$global[\'sp_prog\']->prog->\$global[\'programm\']->slotmax_act;
            \$global[\'sp_edit\']->slotday_act = \$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday_act;
				\$global[\'sp_edit\']->switchPoints = \$global[\'sp_prog\']->prog->\$global[\'programm\']->switchPoints;
					SetValue(\$global[\'sp_editID\'], json_encode(\$global[\'sp_edit\']));

         // Profilanzeige erstellen
      		SetVariable(\"Wochentag\", 0);
      		SetVariable(\"AuswahlSchaltpunkt\", 1);

				\$data = anzeige_erstellen(false);
					\$taganzeige = \$data[\'tag\'];
					\$wocheanzeige = \$data[\'woche\'];
				}

			else{
				meldung(\"015\", 2);
				\$taganzeige = \"Fehlerhafte Daten im Programmspeicher\";
				\$wocheanzeige = \"Fehlerhafte Daten im Programmpeicher\";
				}
			}
		else{
			meldung(\"016\", 2);
			\$taganzeige = \"Fehlerhafte Daten im Speicher\";
			\$wocheanzeige = \"Fehlerhafte Daten im Speicher\";
			}
		}

// -----------------------------------------------------------------------------

// Aufbau Webfront
	if(\$default or \$empty or \$noprog or \$noedit == true){
	// Sichtbarkeit setzen
	   if(\$empty == true){
         change_profil(\$profile[\'ProgrammAktion\'], 1, 0, 0, 0, \"\", \"\", \"auslesen\", \"#3366FF\");
         SetVariable(\"ProgrammAktion\", 0);

			change_link(\"ProgrammAktion\", 1);
	      change_link(\"Editieren\", 0);
	      change_link(\"Aktion\", 0);
	      change_link(\"Umschalten\", 0);
	         SetVariable(\"Umschalten\", -1);
	      change_link(\"KopierenDummy\", 0);
	      change_link(\"SetpointDummy\", 0);
			}
		if(\$noprog == true){
		   change_link(\"ProgrammAktion\", 0);
	      change_link(\"Editieren\", 1);
	      change_link(\"Aktion\", 0);
	      change_link(\"Umschalten\", 0);
	      	SetVariable(\"Umschalten\", -1);
	      change_link(\"KopierenDummy\", 0);
	      change_link(\"SetpointDummy\", 0);
			}
	   if(\$noedit == true){
	      change_link(\"ProgrammAktion\", 0);
	      change_link(\"Editieren\", 0);
	      change_link(\"Aktion\", 0);
	      change_link(\"Umschalten\", 0);
	      	SetVariable(\"Umschalten\", -1);
	      change_link(\"KopierenDummy\", 0);
	      change_link(\"SetpointDummy\", 0);
			}
		}
	else{
	// Sichtbarkeit setzen
	   change_profil(\$profile[\'ProgrammAktion\'], 1, 0, 0, 0, \"\", \"\", \"aktualisieren\", \"#3366FF\");
	   SetVariable(\"ProgrammAktion\", -1);

		change_link(\"ProgrammAktion\", 1);
      change_link(\"Editieren\", 1);
      change_link(\"Aktion\", 0);
      change_link(\"Umschalten\", 1);

	// Variablen, Profile und Links anpassen
	// --------------------------------------------------------------------------
  		foreach(\$global[\'sp_prog\']->lvl as \$key => \$array){
			\$namen[0] = \"\"; \$farben[0] = \"\";
				\$namen[] = \$key;
				\$farben[] = \$color[\$array->name][\'c_n\'];
			unset(\$namen[0]); unset(\$farben[0]);

			if(\$array->minvalue > 0){
			// Sollwertvariablen an Programm anpassen
      		if(\$global[\'system\'][0] == \"h\"){
					change_profil(\$profile[\'Temp_\'.\$array->name], 2, (float)\$array->minvalue, (float)\$array->maxvalue, 0.5, \"\", \" C\", \"\", \"\");
			  		SetVariable(\"Setpoint\".\$array->name, \$array->value);
            	}
         	if(\$global[\'system\'][0] == \"d\"){
			  		change_profil(\$profile[\'Temp_\'.\$array->name], 2, \$array->minvalue, \$array->maxvalue, 1, \"\", \" C\", \"\", \"\");
			  		SetVariable(\"Setpoint\".\$array->name, \$array->value);
            	}
			// Links an Programm anpassen
				change_link(\"Setpoint\".\$array->name, 3, \"Schaltpunkt - \".\$key);
				}
			}
      // Schaltlevel an Programm anpassen
			change_profil(\$profile[\'Level\'], 1, 0, 0, 0, \"\", \"\", \$namen, \$farben);
   // --------------------------------------------------------------------------
		
	// Minutenanzeige auf Timeraster beschrnken
		change_profil(\$profile[\'Minuten\'], 1, 0, 50, \$global[\'sp_prog\']->prog->\$global[\'programm\']->time, \"\", \"\", \"\", \"\");
		}

// -----------------------------------------------------------------------------

	// Variablen schreiben
		SetVariable(\"TagAnzeige\", \$taganzeige);
		SetVariable(\"WocheAnzeige\", \$wocheanzeige);
	}


/*------------------------------------------------------------------------------
	Funktion Slotanzeige (Schaltpunkt) ndern
------------------------------------------------------------------------------*/
function change_slot(\$max){
Global \$profile;

 \$data = IPS_GetVariableProfile(\$profile[\'AuswahlSchaltpunkt\']);

	if(\$data == true){
   	IPS_SetVariableProfileText(\$profile[\'AuswahlSchaltpunkt\'], \"- \", \" -\");
   	IPS_SetVariableProfileValues(\$profile[\'AuswahlSchaltpunkt\'], 1, \$max, 1);
		}
	}


/*------------------------------------------------------------------------------
	Zeitslot einfgen / lschen
------------------------------------------------------------------------------*/
function change_zeitslot(\$function){
Global \$global;

	// Schaltpunkte auslesen
	foreach(\$global[\'sp_edit\']->switchPoints as \$key => \$array){
		\$tmpprog[\$array->dayOfWeek][] = \$array;
		}

	if(\$function == \"change\"){
		// Schaltlevel auslesen und prfen
 		\$level = check_level(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1]->setpoint, true);

		// Zeit umrechnen
		\$time = GetValue(IPS_GetObjectIDByIdent(\"Stunden\", \$global[\'var_parentID\'])).\":\".GetValue(IPS_GetObjectIDByIdent(\"Minuten\", \$global[\'var_parentID\']));
		\$time = strtotime(\"1970-01-01 \$time UTC\") / 60;

		// Schaltpunkt zusammenstellen
	   \$array = (object)array(\"dayOfWeek\" => \$global[\'dayshort\'][\$global[\'wochentag\']], \"setpoint\" => \$level, \"time\" => \$time);

		// Eintrge auf Richtigkeit prfen
		\$result = check_program(\$tmpprog, \$array, \"change\");

		// Ausgabe der nderungen in den Cache
	   if(\$result == \"OK\"){
			\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1]= \$array;

			foreach(\$tmpprog as \$key1 => \$data){
		   	foreach(\$data as \$key2 => \$array){
					\$sp_edit[] = \$array;
					}
				}

         \$global[\'sp_edit\']->switchPoints = \$sp_edit;
			SetValue(\$global[\'sp_editID\'], json_encode(\$global[\'sp_edit\']));
			}
      return \$result;
		}

	if(\$function == \"add\"){
		// Schaltlevel auslesen und prfen
 		\$level = check_level(end(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]])->setpoint, true);

		// Zeit umrechnen
		\$stunden = GetValue(IPS_GetObjectIDByIdent(\"Stunden\", \$global[\'var_parentID\']));
		\$minuten = GetValue(IPS_GetObjectIDByIdent(\"Minuten\", \$global[\'var_parentID\']));
		\$time = \$stunden.\":\".\$minuten;
		\$time = strtotime(\"1970-01-01 \$time UTC\") / 60;

		// Schaltpunkt zusammenfgen
	   \$array = (object)array(\"dayOfWeek\" => \$global[\'dayshort\'][\$global[\'wochentag\']], \"setpoint\" => \$level, \"time\" => \$time);

		// Eintrge auf Richtigkeit prfen
		\$result = check_program(\$tmpprog, \$array, \"add\");

		// Ausgabe der nderungen in den Cache
	   if(\$result == \"OK\"){
			array_push(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]], \$array);

			foreach(\$tmpprog as \$key1 => \$data){
		   	foreach(\$data as \$key2 => \$array){
					\$sp_edit[] = \$array;
					}
				}

         \$global[\'sp_edit\']->switchPoints = \$sp_edit;
			SetValue(\$global[\'sp_editID\'], json_encode(\$global[\'sp_edit\']));;
			}
      return \$result;
		}

	if(\$function == \"del\" and count(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]]) > 1){
	   \$array = (object)array(\"dayOfWeek\" => \$global[\'dayshort\'][\$global[\'wochentag\']], \"setpoint\" => end(\$global[\'sp_prog\']->lvl)->name, \"time\" => \"1440\");
		array_pop(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]]);
		foreach(\$tmpprog as \$key1 => \$data){
		   foreach(\$data as \$key2 => \$array){
				\$sp_edit[] = \$array;
				}
			}

      \$global[\'sp_edit\']->switchPoints = \$sp_edit;
		SetValue(\$global[\'sp_editID\'], json_encode(\$global[\'sp_edit\']));
		}
   return \"OK\";
	}


/*------------------------------------------------------------------------------
	Funktion Schaltlevel prfen
------------------------------------------------------------------------------*/
function check_level(\$level, \$reverse = false){
	Global \$global, \$profile;

	\$profil = IPS_GetVariableProfile(\$profile[\'Level\']);
	\$value = GetValue(IPS_GetObjectIDByIdent(\"Schaltlevel\", \$global[\'var_parentID\']));

	// Klartext-Name vom Schaltlevel auslesen
  	foreach(\$global[\'sp_prog\']->lvl as \$lvl => \$array){
   	if(\$array->name == \$level){
			\$search = \$lvl;
			break;
			}
		}

	// Schaltlevel prfen
	foreach(\$profil[\'Associations\'] as \$key => \$array){
      if(\$reverse == true){
			if(\$array[\'Value\'] == \$value){
				\$value = \$global[\'sp_prog\']->lvl->\$array[\'Name\']->name;
				break;
				}
			}
		else{
		   if(\$array[\'Name\'] == \$search){
				\$value = \$array[\'Value\'];
				break;
				}
			}
		}

	return \$value;
	}


/*------------------------------------------------------------------------------
	Funktion Schaltprogramm prfen
------------------------------------------------------------------------------*/
function check_program(\$sp_edit, \$compare, \$function){
Global \$global;

	if(\$function == \"change\"){
		\$data = \$sp_edit[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1];

		if(\$data->dayOfWeek != \$compare->dayOfWeek){
      	meldung(\"020\", 3);
	   	return \"fehler\";
	   	}
		elseif(\$data->setpoint != \$compare->setpoint){
      	meldung(\"021\", 3);
			return \"fehler\";
	   	}
   	elseif(\$data->time == \$compare->time){
      	meldung(\"022\", 3);
	   	return \"fehler\";
	   	}
		else{
	   	return \"OK\";
	   	}
		}

	if(\$function == \"add\"){
	   \$data = end(\$sp_edit[\$global[\'dayshort\'][\$global[\'wochentag\']]]);

		if(\$data->dayOfWeek != \$compare->dayOfWeek){
      	meldung(\"023\", 3);
	   	return \"fehler\";
	   	}
		elseif(\$data->setpoint == \$compare->setpoint){
      	meldung(\"024\", 3);
			return \"fehler\";
	   	}
   	elseif(\$data->time > \$compare->time){
      	meldung(\"025\", 3);
	   	return \"fehler\";
	   	}
   	elseif(\$global[\'sp_edit\']->slotmax_act >= \$global[\'sp_prog\']->prog->\$global[\'programm\']->slotmax){
      	meldung(\"033\", 3);
	   	return \"slotmax\";
	   	}
   	elseif(\$global[\'sp_edit\']->slotday_act->\$global[\'dayshort\'][\$global[\'wochentag\']] >= \$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday){
      	meldung(\"034\", 3);
	   	return \"slotmax\";
	   	}
		else{
	   	return \"OK\";
	   	}
		}
	}


/*------------------------------------------------------------------------------
	Funktion Meldung schreiben
------------------------------------------------------------------------------*/
function meldung(\$num, \$option){
Global \$global, \$message;

	if(\$option > 0){
	   \$nachTag = GetValue(IPS_GetObjectIDByIdent(\"KopierenNach\", \$global[\'var_parentID\']));

		\$search = array(\"&Wochentag1\", \"&Wochentag2\", \"&Slot\");
		\$replace = array(\$global[\'daylong\'][\$global[\'wochentag\']], \$global[\'daylong\'][\$nachTag], \$global[\'slot\']);

		\$data = str_replace(\$search, \$replace, \$message[\$num]);
		\$data = explode(\"|\", \$data);
		}
	else{
	   \$data = explode(\"|\", \$message[\$num]);
	   }

	switch(\$option){
	   case 0:
	      \$text = \"Auswahl: \".\$data[0].\"\";
		break;
	   case 1:
	      \$text = \"Auswahl: \".\$global[\'auswahl\'].\"&nbsp;&nbsp;&boxv;&nbsp;&nbsp;\".\$data[0].\"\";
		break;
	   case 2:
	      \$text = \"Auswahl: \".\$global[\'auswahl\'].\"&nbsp;&nbsp;&boxv;&nbsp;&nbsp;Programm: \".\$global[\'programm\'];
		break;
	   case 3:
	      \$text = \"Auswahl: \".\$global[\'auswahl\'].\"&nbsp;&nbsp;&boxv;&nbsp;&nbsp;Programm: \".\$global[\'programm\'];
		break;
		}

	\$content = \"<table border = 0	 cellpadding = 0 cellspacing = 0 align = \'left\'>
						<tr height = 30px>
                  	<td align = \'left\'>\".\$text.\"\";

	if(array_key_exists(0, \$data) and \$option > 1){\$content .= \"&nbsp;&nbsp;&nbsp;&boxH;&vltri;&nbsp;&nbsp;&nbsp;\".\$data[0].\"</td></tr>\";}   //&boxH;&vltri;
   else{\$content .= \"</td></tr>\";}

	if(array_key_exists(1, \$data) and \$option == 3){
	\$content .= \"<tr height = 28px>
						<td align = \'left\'>&nbsp;&nbsp;&nbsp;&nbsp;&rdsh;&nbsp;&nbsp;\".\$data[1].\"</td>
					 </tr>\"; // &angrt;
					 }
   else{
	\$content .= \"<tr height = 28px>
						<td align = \'left\'></td>
					 </tr>\";
					 }

	\$content .= \"</table>\";

	SetVariable(\"Meldung\", \$content);
	}


/*------------------------------------------------------------------------------
	Funktion HTML-Tabellen Wochenprofil und Tagesprofil erstellen
------------------------------------------------------------------------------*/
function anzeige_erstellen(\$set = true){
Global \$global, \$color, \$profile;

	\$sp_edit = json_decode(GetValue(\$global[\'sp_editID\']));

// Wochenprofil
// -------------
	// Schaltpunkte auslesen
	foreach(\$sp_edit->switchPoints as \$key => \$array){
		\$tmpprog[\$array->dayOfWeek][] = \$array;
		\$pos = each(\$tmpprog[\$array->dayOfWeek]);
		   \$tmpprog[\$array->dayOfWeek][\$pos[\'key\']]->time = date(\"H:i\", strtotime(floor(\$array->time/60).\":\".(\$array->time%60)));
		}

// -----------------------------------------------------------------------------

	// Programm zerlegen
	// ------------------
	foreach(\$global[\'dayshort\'] as \$daykey => \$day){
		// Zeitlinie zusammenfgen
		\$timeStart = \"0\";
		foreach(\$tmpprog[\$day] as \$array){
		\$time24 = \$array->time;
		\$timeEnd = strtotime(\"1970-01-01 \$time24 UTC\") / 60;
			\$times[\$day][] = floor((\$timeEnd - \$timeStart) / 5);
			\$timeStart = \$timeEnd;
			}

		// Schaltlevel
		foreach(\$tmpprog[\$day] as \$array){
			\$lvl[\$day][] = \$array->setpoint;
			}
		}

// -----------------------------------------------------------------------------

	// Zeiten prfen und erweitern fr Anzeige
	foreach(\$times as \$key => \$array){
	   if(\$array[0] == 0){
			if(count(\$array) > 1){unset(\$times[\$key][0]);}
			else{\$times[\$key][0] = 288;}
			}
		elseif(array_sum(\$array) < 288){
			\$sum = array_sum(\$array);
			array_push(\$times[\$key], (288 - \$sum));
			}
		}

	// Schaltlevel erweitern fr Anzeige
	foreach(\$lvl as \$key => \$array){
		if(\$key == \"Mo\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Su\']));}
		if(\$key == \"Tu\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Mo\']));}
		if(\$key == \"We\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Tu\']));}
		if(\$key == \"Th\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'We\']));}
		if(\$key == \"Fr\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Th\']));}
		if(\$key == \"Sa\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Fr\']));}
		if(\$key == \"Su\" and count(\$times[\$key]) > 1){array_unshift(\$lvl[\$key], end(\$lvl[\'Sa\']));}
		}

// -----------------------------------------------------------------------------

// HTML Tabelle generieren
// ------------------------
	\$data[\'woche\'] = \'<style type=\"text/css\">.tdstd {border-right: 1px solid #ffffff;}</style>
		<table border = 0 cellpadding = 0 cellspacing = 0 width = 100% align = \"left\">
			<tr height = 30px align = \"left\">
				<td align = \"center\" width = 3% id = tdstd></td>\';

	for(\$i = 0; \$i <= 23; \$i++){
	   \$data[\'woche\'] .=
				\"<td colspan = 12 width = 3% align = \'center\' id = tdstd>\$i</td>\";
		}

	\$data[\'woche\'] .= \'
			</tr>\';
	foreach(\$global[\'dayshort\'] as \$daykey => \$day){
		\$data[\'woche\'] .= \"
			<tr height = 30px align = \'center\'><td>\".\$global[\'dayshort_de\'][\$daykey].\"</td>\";

		foreach(\$times[\$day] as \$key => \$time){
			if(\$global[\'wochentag\'] <> \$daykey){
				\$data[\'woche\'] .= \"
				<td colspan=\".\$time.\" bgcolor=\".\$color[\$lvl[\$day][\$key]][\'c_n\'].\"></td>\";
				}
			else{
				\$data[\'woche\'] .= \"
				<td colspan=\".\$time.\" bgcolor=\".\$color[\$lvl[\$day][\$key]][\'c_hl\'].\"></td>\";
				}
			}

		\$data[\'woche\'] .= \"
			</tr>\";
		}

	\$data[\'woche\'] .= \"
		</table><br>\";

   \$data[\'woche\'] .= \"
		<table border = 0 cellpadding = 3 cellspacing = 5 align = \'left\'>
			<tr height = 25>
				<td width = 40px align = \'left\'> Index: </td>\";

	   foreach(\$global[\'sp_prog\']->lvl as \$key => \$array){
	      if(\$array->value > 0){
        		\$data[\'woche\'] .= \"
					<td width = 160px bgcolor = \".\$color[\$array->name][\'c_n\'].\" align = \'center\'>\".\$key.\"&nbsp;&nbsp;-&nbsp;&nbsp;\".\$array->value.\" C</td>\";
				}
	      else{
        		\$data[\'woche\'] .= \"
					<td width = 160px bgcolor = \".\$color[\$array->name][\'c_n\'].\" align = \'center\'>\".\$key.\"</td>\";
				}
			}

	\$data[\'woche\'] .= \"
			</tr>
		</table>\";

// -----------------------------------------------------------------------------

// Tagesprofil
// -----------------------------------------------------------------------------
	\$startTime = \"00:00\";
	\$data[\'tag\'] = \"
			<table width = 90% border = 0 cellpadding = 3 cellspacing = 3 align = \'center\'>
				<tr height = 30 >
					<th>Schaltpunkt</th><th>Start</th><th>Ende</th><th>Level</th>
				</tr>\";

	if(end(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]])->time <> \"24:00\"){
		\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][] = (object)array(\"dayOfWeek\" => \$global[\'dayshort\'][\$global[\'wochentag\']], \"setpoint\" => end(\$lvl[\$global[\'dayshort\'][\$global[\'wochentag\']]]), \"time\" => \'24:00\');
		}

	\$pos = 0;
	foreach(\$global[\'sp_prog\']->lvl as \$key => \$array){
      \$tmplvl[\$array->name] = \$key;
      }

	foreach(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]] as \$key => \$array){
			if(\$pos == 0){
				\$data[\'tag\'] .= \"
					<tr align = \'center\' height = 25>
						<td width = 25%>- - -</td>
						<td width = 25%>\".\$startTime.\"</td>
						<td width = 25%>\".\$array->time.\"</td>
						<td width = 25%>\".\$tmplvl[\$lvl[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$pos]].\"</td>
					 </tr>\";
				}
			else{
				if(\$pos <> \$global[\'slot\']){
				\$data[\'tag\'] .= \"
					<tr align = \'center\' height = 25>
						<td width = 25%>- \".\$pos.\" -</td>
						<td width = 25%>\".\$startTime.\"</td>
						<td width = 25%>\".\$array->time.\"</td>
						<td width = 25%>\".\$tmplvl[\$lvl[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$pos]].\"</td>
					 </tr>\";
					}
				else{
				\$data[\'tag\'] .= \"
					<tr bgcolor = #1A2B3C align = \'center\' height = 25>
						<td width = 25%>- \".\$pos.\" -</td>
						<td width = 25%>\".\$startTime.\"</td>
						<td width = 25%>\".\$array->time.\"</td>
						<td width = 25%>\".\$tmplvl[\$lvl[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$pos]].\"</td>
					</tr>\";
					}
				}

      if(\$array->time == \"24:00\"){

	      break;
	      }

      \$pos++;
		\$startTime = \$array->time;
		}

	\$data[\'tag\'] .= \"</table>\";


	// Daten fr Visualisierung aufbereiten
		\$stunden = substr(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1]->time, 0, 2);
		\$minuten = substr(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1]->time, -2);
		\$level = check_level(\$tmpprog[\$global[\'dayshort\'][\$global[\'wochentag\']]][\$global[\'slot\']-1]->setpoint);

	// Auswahl-Zeit-Slot auf Anzahl der belegten Slots beschrnken
   	change_slot(\$pos);

	// Variable Information schreiben
		// maximale Anzahl der TimeSlots
			\$global[\'sp_edit\']->slotmax_act = count(\$global[\'sp_edit\']->switchPoints);

		// maximale Anzahl der TimeSlots pro Tag
  			\$days = array(\"Mo\" => 0, \"Tu\" => 0, \"We\" => 0, \"Th\" => 0, \"Fr\" => 0, \"Sa\" => 0, \"Su\" => 0);
				foreach(\$global[\'sp_edit\']->switchPoints as \$key => \$array){\$days[\$array->dayOfWeek]++;}

			\$global[\'sp_edit\']->slotday_act->Mo = \$days[\'Mo\'];
			\$global[\'sp_edit\']->slotday_act->Tu = \$days[\'Tu\'];
			\$global[\'sp_edit\']->slotday_act->We = \$days[\'We\'];
			\$global[\'sp_edit\']->slotday_act->Th = \$days[\'Th\'];
			\$global[\'sp_edit\']->slotday_act->Fr = \$days[\'Fr\'];
			\$global[\'sp_edit\']->slotday_act->Sa = \$days[\'Sa\'];
			\$global[\'sp_edit\']->slotday_act->Su = \$days[\'Su\'];

	   \$text  = \"Schaltpunkte pro Tag: \".\$global[\'sp_edit\']->slotday_act->\$global[\'dayshort\'][\$global[\'wochentag\']];
		\$text .= \" von \".\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotday.\" | Gesamt: \".\$global[\'sp_edit\']->slotmax_act;
		\$text .= \" von \".\$global[\'sp_prog\']->prog->\$global[\'programm\']->slotmax;

		SetVariable(\"ProgrammInfo\", \$text);


	if(\$set == true){
		// Variablen schreiben
		SetVariable(\"TagAnzeige\", \$data[\'tag\']);
		SetVariable(\"WocheAnzeige\", \$data[\'woche\']);
		SetVariable(\"Stunden\", \$stunden);
		SetVariable(\"Minuten\", \$minuten);
		SetVariable(\"Schaltlevel\", \$level);
		}
	else{
		return \$data;
		}
	}


/*------------------------------------------------------------------------------
	Funktion Programm an Steuerung senden
------------------------------------------------------------------------------*/
function write_program(\$url, \$prog){
	\$content = json_encode(\$prog);

	\$options = array(
   	\'http\' => array(
      \'method\' => \"PUT\",
      \'header\' => \"Content-type: application/json\r\n\" .
                  \"User-Agent: TeleHeater/2.2.3\r\n\",
      \'content\' => km200_Encrypt(\$content)
      )
	);

	\$context = stream_context_create(\$options);
   file_get_contents(
   	\'http://\'.km200_gateway_host.\':\'.km200_gateway_port.\$url,
      false,
      \$context
    	);
	}

// *****************************************************************************
// *****************************************************************************

?>";

	IPS_SetScriptContent($sid_func, $content);


// *****************************************************************************


// Installation Konfigurations-Skript
// -----------------------------------

$content = \'<?
/*******************************************************************************

	MSC - Version '.$version.' vom '.$datum.'
	
********************************************************************************


								KONFIGURATIONS-SKRIPT


********************************************************************************

	!! Farben und Meldungen knnen angepasst werden !!

*******************************************************************************/


// Farben fr die einzelnen Schaltlevel
// -------------------------------------
	$color = array(
	// Heizkreis';
$color = array(0 => '"#ffaa00",		// orange',
					1 => '"#ff7700",		// orange dunkel',
					2 => '"#33aa00",		// grn',
					3 => '"#337700",		// grn dunkel',
					4 => '"#ffaa00",		// orange',
					5 => '"#ff7700",		// orange dunkel',
					6 => '"#33aa00",		// grn',
					7 => '"#337700",		// grn dunkel',
					8 => '"#ffaa00",		// orange',
					9 => '"#ff7700",		// orange dunkel',
					10 => '"#33aa00",		// grn',
					11 => '"#337700",		// grn dunkel',
					12 => '"#aaaaaa",		// grau',
					13 => '"#888888",		// grau dunkel',
					14 => '"#0077ff",		// blau',
					15 => '"#0077cc",		// blau dunkel',
					16 => '"#aaaaaa",		// grau',
					17 => '"#888888",		// grau dunkel',
					18 => '"#0077ff",		// blau',
					19 => '"#0077cc",		// blau dunkel'
					);

$count = 0;
foreach(array_unique($level['hk']['lvl']) as $key => $value){
	$content .= '
	"'.$value.'" => array(
				"c_n" => '.$color[$count].',';
				$count++;
   $content .= '
				"c_hl" => '.$color[$count].'
				),';
				$count++;
	}

$content .= '

	// Warmwasser';
$target = count(array_unique($level['dhw']['lvl']));
$count = 12;
foreach(array_unique($level['dhw']['lvl']) as $key => $value){
	$content .= '
	"'.$value.'" => array(
				"c_n" => '.$color[$count].',';
				$count++;
	$content .= '
				"c_hl" => '.$color[$count].'';
				$count++;
	if($count == ($target + 14)){
	$content .= '
				));';
		}
	else{
	$content .= '
				),';
		}
	
	}
	
   $content .= '

// *****************************************************************************

// Array mit den Meldungen
// ------------------------
$message = array(
		"000" => "kein System ausgewhlt ...",
		"001" => "kein Programm ausgewhlt ...",
		"002" => "Reservemeldung",
		"003" => "Reservemeldung",
		"004" => "Reservemeldung",
		"005" => "wird ausgelesen ...",
		"006" => "erfolgreich ausgelesen ...",
		"007" => "erfolgreich ausgelesen ...|Aber es befinden sich keine Schaltpunkte im Programm zum Abspeichern ...",
		"008" => "konnte nicht ausgelesen werden ...|Keine Daten vorhanden und/oder Verbindung zum KM200 fehlerhaft",
		"009" => "Reservemeldung",
		"010" => "noch nicht ausgelesen ...",
		"011" => "keine Daten vorhanden ...",
		"012" => "geladen ...",
		"013" => "kann nicht editiert werden!",
		"014" => "nderungen erfolgreich bernommen",
		"015" => "Fehler beim Laden des Programmes!",
		"016" => "Fehler beim Laden des Speichers!",
		"017" => "Fehler! nderung nicht bernommen.",
		"018" => "Schaltpunkt gelscht",
		"019" => "Schaltpunkt einfgen aktiv!",
		"020" => "Fehler Wochentag|Einstellung des Wochentages ist falsch!",
		"021" => "Fehler Schaltlevel|Einstellung Schaltlevel falsch!&nbsp;&srarr;&nbsp;Schaltlevels mssen unterschiedlich sein",
		"022" => "Fehler Uhrzeit|Einstellung Uhrzeit falsch!&nbsp;&srarr;&nbsp;die Uhrzeit muss unterschiedlich sein",
		"023" => "Zeitslot einfgen aktiv!|Einstellung des Wochentages ist falsch!",
		"024" => "Zeitslot einfgen aktiv!|Einstellung Schaltlevel falsch!&nbsp;&srarr;&nbsp;Schaltlevels mssen unterschiedlich sein",
		"025" => "Zeitslot einfgen aktiv!|Einstellung Uhrzeit falsch!&nbsp;&srarr;&nbsp;die Uhrzeit muss grer sein",
		"026" => "Daten werden gesendet ...",
		"027" => "Daten berprfen ...",
		"028" => "bertragung war erfolgreich!",
		"029" => "Fehler bei der bertragung ...",
		"030" => "&Wochentag1 ausgewhlt",
		"031" => "Schaltpunkt&nbsp;&nbsp;- &Slot -&nbsp;&nbsp;ausgewhlt",
		"032" => "Tag erfolgreich kopiert|&Wochentag1 kopiert auf &Wochentag2",
		"033" => "Schaltpunkt einfgen nicht mglich|maximale Anzahl Schaltpunkte gesamt erreicht!",
		"034" => "Schaltpunkt einfgen nicht mglich|maximale Anzahl Schaltpunkte pro Tag erreicht!"
		);



// *****************************************************************************
// AB HIER BITTE KEINE NDERUNGEN VORNEHMEN
// *****************************************************************************

// Namen zu den Variablenprofilen
// -------------------------------
	$profile = array(
			"Wochentag" 			=> "\'.$profil_wochentag.\'",
			"AuswahlSchaltpunkt"	=> "\'.$profil_auswahl_schaltpunkt.\'",
			"Stunden" 				=> "\'.$profil_stunden.\'",
			"Minuten" 				=> "\'.$profil_minuten.\'",
			"Level" 					=> "\'.$profil_level.\'",
			"Schaltpunkt"		 	=> "\'.$profil_schaltpunkt.\'",
			"Aktion"		 			=> "\'.$profil_aktion.\'",
			"Umschalten" 			=> "\'.$profil_umschalten.\'",
			"KopierenNach"			=> "\'.$profil_kopieren_nach.\'",
			"Kopieren"				=> "\'.$profil_kopieren.\'",
			"Setpoint"           => "\'.$profil_setpoint.\'",
			"Auswahl" 				=> "\'.$profil_auswahl.\'",
			"Programm" 				=> "\'.$profil_programm.\'",
			"ProgrammAktion"		=> "\'.$profil_aktion.\'",';
		foreach(array_unique($level['var']['hc']) as $key => $value){
			$content .= '
         "Temp_'.$value.'"				=> "\'.$profil_temp_'.$value.'.\'",';
         }
		foreach(array_unique($level['var']['dhw']) as $key => $value){
			$content .= '
         "Temp_'.$value.'"				=> "\'.$profil_temp_'.$value.'.\'",';
         }
		$content .= '
		   );

// *****************************************************************************
// *****************************************************************************

?>\';

	IPS_SetScriptContent($sid_conf, $content);


// *****************************************************************************

// Initialisierung Variablen
	SetVariable("Meldung", $ed_parent, "Installation erfolgreich abgeschlossen :-)");
	SetVariable("ProgrammInfo", $ed_parent, "");
	SetVariable("Wochentag", $ed_parent, 0);
	SetVariable("Stunden", $ed_parent, 0);
	SetVariable("Minuten", $ed_parent, 0);
	SetVariable("Schaltlevel", $ed_parent, -1);
	SetVariable("Schaltpunkt", $ed_parent, -1);
	SetVariable("Aktion", $ed_parent, -1);
	SetVariable("Umschalten", $ed_parent, -1);
	SetVariable("KopierenNach", $ed_parent, 0);
	SetVariable("Kopieren", $ed_parent, -1);
	SetVariable("EditSetpoint", $ed_parent, -1);
	SetVariable("Auswahl", $ed_parent, 0);
	SetVariable("Programm", $ed_parent, 0);
	SetVariable("ProgrammAktion", $ed_parent, -1);
	SetVariable("TagAnzeige", $ed_parent, "Installation erfolgreich abgeschlossen :-)");
	SetVariable("WocheAnzeige", $ed_parent, "Installation erfolgreich abgeschlossen :-)");
	SetVariable("EditSpeicher", $ed_parent, "");
	
// *****************************************************************************

	// Start-Skript
	$sid = IPS_GetScriptIDByName("Start", $parentID);
		IPS_SetParent($sid, $del_parent);
		IPS_SetPosition($sid, 1);
	// Installationsskript
	$sid = IPS_GetScriptIDByName("Install_Start", $parentID);
		IPS_SetParent($sid, $del_parent);
		IPS_SetPosition($sid, 2);

// *****************************************************************************
// *****************************************************************************


/*******************************************************************************

	FUNKTIONEN

*******************************************************************************/

function SetVariable($name, $id, $newvalue){
	$vid = @IPS_GetObjectIDByIdent($name, $id);
	SetValue($vid, $newvalue);
	}

function SetKatByName($parentID, $name, $ident, $position){
	$kid = @IPS_GetCategoryIDByName($name, $parentID);
	if($kid === false){
		$kid = IPS_CreateCategory();       //Kategorie anlegen
			IPS_SetName($kid, $name); 		//Kategorie benennen
			IPS_SetParent($kid, $parentID);
         IPS_SetPosition ($kid, $position);

		if($ident !== ""){IPS_SetIdent($kid , $ident);}
		}

	return $kid;
	}

function SetDummyByName($parentID, $name, $ident, $position){
	$did = @IPS_GetInstanceIDByName($name, $parentID);
	if($did === false){
		$did = IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}"); // Dummy anlegen
			IPS_SetName($did, $name);
			IPS_SetParent($did, $parentID);
        	IPS_SetPosition ($did, $position);

		if($ident !== ""){IPS_SetIdent($did, $ident);}
		}
	return $did;
	}

function SetLinkByName($parentID, $name, $targetID, $ident, $position){
	$rootID = IPS_GetParent($_IPS[\'SELF\']);
	$var_parentID = IPS_GetObjectIDByName("Editor", $rootID);
	$targetID = IPS_GetVariableIDByName($targetID, $var_parentID);

	$lid = @IPS_GetLinkIDByName($name, $parentID);
	if($lid === false){
		$lid = IPS_CreateLink();       	//Link anlegen
			IPS_SetName($lid, $name); 		//Link benennen
			IPS_SetLinkTargetID($lid, $targetID);
         IPS_SetParent($lid, $parentID);
         IPS_SetPosition ($lid, $position);

      if($ident !== ""){IPS_SetIdent($lid, $ident);}
		  	}

	return $lid;
	}

function CreateVariableByName($parentID, $name, $type, $profile, $ident, $skript, $position){
	$vid = @IPS_GetVariableIDByName($name, $parentID);
   if($vid === false){
      $vid = IPS_CreateVariable($type);
      	IPS_SetParent($vid, $parentID);
        	IPS_SetName($vid, $name);
			IPS_SetPosition ($vid, $position);

		if($skript !== ""){IPS_SetVariableCustomAction($vid, $skript);}
		if($profile !== ""){IPS_SetVariableCustomProfile($vid, $profile);}
		if($ident !== ""){IPS_SetIdent($vid, $ident);}
		}

	return $vid;
   }

function create_profil($profil, $typ, $min, $max, $step, $pre, $suf, $asso, $color = false){
 $data = @IPS_GetVariableProfile($profil);

	if($data == true){
		// Eintrge lschen
		foreach($data[\'Associations\'] as $key => $array){
			@IPS_SetVariableProfileAssociation($profil, $key, "", "", -1);
			}
		}
	else{
	  	@IPS_CreateVariableProfile($profil, $typ);
		IPS_SetVariableProfileValues($profil, $min, $max, $step);
		}

// -----------------------------------------------------------------------------

   // neue Eintrge erstellen
   IPS_SetVariableProfileValues($profil, $min, $max, $step);

	if(is_array($asso) == true){
		foreach($asso as $key => $value){
	   	IPS_SetVariableProfileText($profil, $pre, $suf);
	   	if($color == false){
				@IPS_SetVariableProfileAssociation($profil, $key, $value, "", -1);
			   }
			else{
				@IPS_SetVariableProfileAssociation($profil, $key, $value, "", hexdec($color[$key]));
			   }
			}
		}
	else{
   	IPS_SetVariableProfileText($profil, $pre, $suf);
   	if($color == false){
  			@IPS_SetVariableProfileAssociation($profil, 0, $asso, "", -1);
  			}
   	else{
  			@IPS_SetVariableProfileAssociation($profil, 0, $asso, "", hexdec($color));
  			}
		}
	}
?>';



	if(@IPS_GetScriptIDByName("Install_Start", $parentID) == false){
		$skript = IPS_CreateScript(0);

		IPS_SetParent($skript, $parentID);
		IPS_SetName($skript, "Install_Start");
		IPS_SetScriptContent($skript, $content);
		}

?>